﻿using System;
using System.Collections.Generic;
using System.Net.Http;
using TpmDAO.Entity;
using TpmDAO.Persistence;
using System.Linq;
using System.Web.Http;
using System.Text.RegularExpressions;
using Utils;
using System.Threading;
using TpmDAO.Persistence.Achievements;

namespace TpmAPI.Controllers
{
    [RoutePrefix("api/match")]
    public class MatchController : BaseController
    {
        [HttpPut]
        [Route("registerSimpleMatch")]
        public HttpResponseMessage RegisterSimpleMatch(TpmDAO.Entity.Match Match)
        {
            var Response = new HttpResponseMessage();
            try
            {
                MatchDAO.Insert(Match);

                TotalStatsDAO.UpdateTotalStats(ref Match);

                UserAchievementsDAO.UpdateUserAchievements(Match);

                return SuccessTreatment(Match, Request);
            }
            catch (Exception e)
            {
                return ExceptionTreatment(e, Request, "Message Here");
            }
        }

        [HttpPut]
        [Route("umpireMatches")]
        public HttpResponseMessage UmpireMatches(List<CategoriesInTournament> CategoriesInTournament)
        {
            var Response = new HttpResponseMessage();
            try
            {
                var Matches = MatchDAO.GetMatchesForUmpire(CategoriesInTournament.First());

                return SuccessTreatment(Matches, Request);
            }
            catch (Exception e)
            {
                return ExceptionTreatment(e, Request, "Message Here");
            }
        }

        [HttpPut]
        [Route("registerUmpireMatch")]
        public HttpResponseMessage RegisterUmpireMatch(TpmDAO.Entity.Match Match)
        {
            var Response = new HttpResponseMessage();
            try
            {
                MatchDAO.Update(Match);
                StatsDAO.Update(Match.MatchStats.First());
                StatsDAO.Update(Match.MatchStats.Last());
                if (Match.IdNextMatch.HasValue)
                {
                    var Stat = new Stats();
                    Stat.IdMatch = Match.IdNextMatch.Value;                  
                    Stat.IdPerson = Match.MatchStats.Where(x => x.Result == "W").FirstOrDefault().IdPerson;
                    StatsDAO.Insert(Stat);
                }
                else
                {
                    var CategoriesInTournament = CategoriesInTournamentDAO.GetByMatch(Match);
                    CategoriesInTournament.Over = true;
                    CategoriesInTournamentDAO.Update(CategoriesInTournament);
                    TournamentDAO.UpdateOver(CategoriesInTournament.IdTournament);
                }

                TotalStatsDAO.UpdateTotalStats(ref Match);
                UserAchievementsDAO.UpdateUserAchievements(Match);

                return SuccessTreatment(Match, Request);
            }
            catch (Exception e)
            {
                return ExceptionTreatment(e, Request, "Message Here");
            }
        }

        [HttpPut]
        [Route("getSimpleMatches")]
        public HttpResponseMessage GetSimpleMatches(List<Person> Person)
        {
            var Response = new HttpResponseMessage();
            try
            {
                var Matches = MatchDAO.GetSimpleMatches(Person.First());

                return SuccessTreatment(Matches, Request);
            }
            catch (Exception e)
            {
                return ExceptionTreatment(e, Request, "Message Here");
            }
        }
    }
}