﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TpmDAO.Entity
{
    [Table("Address")]
    public class Address
    {
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        [Key, Column("idAddress")]
        public int IdAddress { get; set; }

        [Column("street")]
        [MaxLength(100)]
        public string Street { get; set; }

        [Column("number")]
        public int? Number { get; set; }

        [Column("zipCode")]
        [MaxLength(15)]
        public string ZipCode { get; set; }

        [Column("detail")]
        [MaxLength(200)]
        public string Detail { get; set; }

        [Column("neighborhood")]
        [MaxLength(100)]
        public string Neighborhood { get; set; }

        [Column("idCity"), ForeignKey("City")]
        public int IdCity { get; set; }

        [Column("latitude")]
        public double? Latitude { get; set; }

        [Column("longitude")]
        public double? Longitude { get; set; }

        public virtual City City { get; set; }

        public override string ToString()
        {
            return Street + ", " +
                Number + ", " +
                Neighborhood + ", " +
                City.NameCity + ", " +
                City.State.NameState + ", " + (!string.IsNullOrEmpty(ZipCode) ?
                new string(ZipCode.Take(5).ToArray()) + "-" + new string(ZipCode.Skip(5).ToArray()) : "");
        }

    }
}
