﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Script.Serialization;

namespace TpmDAO.Entity
{
    [Table("Category")]
    public class Category
    {
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        [Key, Column("idCategory")]
        public int IdCategory { get; set; }

        [Column("idCategoryAge"), ForeignKey("CategoryAge")]
        public int IdCategoryAge { get; set; }

        [Column("idCategoryGender"), ForeignKey("CategoryGender")]
        public int IdCategoryGender { get; set; }

        [Column("idCategoryClass"), ForeignKey("CategoryClass")]
        public int IdCategoryClass { get; set; }

        [NotMapped]
        public string Description { get; set; }

        public virtual CategoryClass CategoryClass { get; set; }

        public virtual CategoryGender CategoryGender { get; set; }

        public virtual CategoryAge CategoryAge { get; set; }

        [ScriptIgnore]
        public virtual ICollection<Tournament> Tournaments { get; set; }

        [ScriptIgnore]
        public virtual ICollection<CategoriesInTournament> Categories { get; set; }

        [ScriptIgnore]
        public virtual ICollection<EnrolledPlayers> Players { get; set; }
    }
}
