﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TpmDAO.Entity;

namespace TpmDAO.Entity
{
    [Table("Facility")]
    public class Facility
    {
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        [Key, Column("idFacility")]
        public int IdFacility { get; set; }

        [Column("nameFacility")]
        [MaxLength(50)]
        public string NameFacility { get; set; }

        [Column("owner")]
        public int Owner { get; set; }

        [Column("phone")]
        [MaxLength(11)]
        public string Phone { get; set; }

        [Column("email")]
        [MaxLength(50)]
        public string Email { get; set; }

        [Column("status")]
        public bool Status { get; set; } = true;

        [Column("description")]
        [MaxLength(500)]
        public string Description { get; set; }

        [Column("idAddress"), ForeignKey("Address")]
        public int IdAddress { get; set; }

        public virtual Address Address { get; set; }

        public virtual ICollection<FacilityPicture> Pictures { get; set; }

        public virtual ICollection<Tournament> Tournaments { get; set; }

    }
}
