﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TpmDAO.Entity
{
    [Table("Match")]
    public class Match
    {
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        [Key, Column("idMatch")]
        public int IdMatch { get; set; }

        [Column("dateMatch")]
        public DateTime? DateMatch { get; set; }

        [Column("duration")]
        public TimeSpan? Duration { get; set; }

        [Column("idSurface"), ForeignKey("Surface")]
        public int? IdSurface { get; set; }

        [Column("idRound"), ForeignKey("Round")]
        public int? IdRound { get; set; }

        [Column("idNextMatch"), ForeignKey("NextMatch")]
        public int? IdNextMatch { get; set; }

        [Column("idTournament"), ForeignKey("Tournament")]
        public int? IdTournament { get; set; }

        [Column("idDraw"), ForeignKey("Draw")]
        public int? IdDraw { get; set; }

        [Column("sequence")]
        public int? Sequence { get; set; }

        [Column("byeMatch")]
        public bool ByeMatch { get; set; }

        [Column("woMatch")]
        public bool WoMatch { get; set; }

        [Column("over")]
        public bool Over { get; set; }

        [NotMapped]
        public int NextMatchTemp { get; set; }

        public virtual Surface Surface { get; set; }

        public virtual Round Round { get; set; }

        public virtual Match NextMatch { get; set; }

        public virtual Tournament Tournament { get; set; }

        public virtual Draw Draw { get; set; }

        public virtual ICollection<Stats> MatchStats { get; set; }

    }
}
