﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TpmDAO.Entity
{
    [Table("Stats")]
    public class Stats
    {
        [Key, Column("idMatch", Order = 0), ForeignKey("Match")]
        public int IdMatch { get; set; }

        [Key, Column("idPerson", Order = 1), ForeignKey("Person")]
        public int IdPerson { get; set; }

        [Column("result")]
        [MaxLength(1)]
        public string Result { get; set; }

        [Column("totalPointsWon")]
        public int TotalPointsWon { get; set; }

        [Column("totalPointsLost")]
        public int TotalPointsLost { get; set; }

        [Column("aces")]
        public int Aces { get; set; }

        [Column("doubleFaults")]
        public int DoubleFaults { get; set; }

        [Column("forehandWinners")]
        public int ForehandWinners { get; set; }

        [Column("backhandWinners")]
        public int BackhandWinners { get; set; }

        [Column("forehandUnforcedErrors")]
        public int ForehandUnforcedErrors { get; set; }

        [Column("backhandUnforcedErrors")]
        public int BackhandUnforcedErrors { get; set; }

        [Column("forcedErrors")]
        public int ForcedErrors { get; set; }

        [Column("volleyForehandWinners")]
        public int VolleyForehandWinners { get; set; }

        [Column("volleyBackhandWinners")]
        public int VolleyBackhandWinners { get; set; }

        [Column("volleyForehandUnforcedErrors")]
        public int VolleyForehandUnforcedErrors { get; set; }

        [Column("volleyBackhandUnforcedErrors")]
        public int VolleyBackhandUnforcedErrors { get; set; }

        [Column("smashWinners")]
        public int SmashWinners { get; set; }

        [Column("smashErrors")]
        public int SmashErrors { get; set; }

        [Column("totalPointsServing")]
        public int TotalPointsServing { get; set; }

        [Column("totalPointsReceiving")]
        public int TotalPointsReceiving { get; set; }

        [Column("totalFirstServeIn")]
        public int TotalFirstServeIn { get; set; }

        [Column("totalSecondServeIn")]
        public int TotalSecondServeIn { get; set; }

        [Column("totalFirstServePointsWon")]
        public int TotalFirstServePointsWon { get; set; }

        [Column("totalSecondServePointsWon")]
        public int TotalSecondServePointsWon { get; set; }

        [Column("dropshotWinners")]
        public int DropshotWinners { get; set; }

        [Column("dropshotErrors")]
        public int DropshotErrors { get; set; }

        [Column("firstSetGames")]
        public int FirstSetGames { get; set; }

        [Column("secondSetGames")]
        public int SecondSetGames { get; set; }

        [Column("thirdSetGames")]
        public int ThirdSetGames { get; set; }

        public virtual Match Match { get; set; }

        public virtual Person Person { get; set; }
    }
}
