﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TpmDAO.Entity
{
    [Table("Message")]
    public class Message
    {
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        [Key, Column("idMessage")]
        public int IdMessage { get; set; }

        [Column("subject")]
        [MaxLength(50)]
        public string Subject { get; set; }

        [Column("content")]
        [MaxLength(1000)]
        public string MessageBody { get; set; }

        [Column("idUser"), ForeignKey("User")]
        public int IdUser { get; set; }

        [Column("sendDate")]
        public DateTime Date { get; set; }

        [Column("read")]
        public bool IsRead { get; set; } = false;

        [Column("readDate")]
        public DateTime? ReadDate { get; set; }

        public virtual User User { get; set; }
    }
}
