﻿using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace TpmDAO.Entity
{
    [Table("TotalStats")]
    public class TotalStats
    {
        [Key, Column("idPerson"), ForeignKey("Person")]
        public int IdPerson { get; set; }

        [Column("totalWins")]
        public int TotalWins { get; set; }

        [Column("totalLoses")]
        public int TotalLoses { get; set; }

        [Column("totalPointsWon")]
        public int TotalPointsWon { get; set; }

        [Column("totalPointsLost")]
        public int TotalPointsLost { get; set; }

        [Column("totalAces")]
        public int TotalAces { get; set; }

        [Column("totalDoubleFaults")]
        public int TotalDoubleFaults { get; set; }

        [Column("totalForehandWinners")]
        public int TotalForehandWinners { get; set; }

        [Column("totalBackhandWinners")]
        public int TotalBackhandWinners { get; set; }

        [Column("totalForehandUnforcedErrors")]
        public int TotalForehandUnforcedErrors { get; set; }

        [Column("totalBackhandUnforcedErrors")]
        public int TotalBackhandUnforcedErrors { get; set; }

        [Column("totalForcedErrors")]
        public int TotalForcedErrors { get; set; }

        [Column("totalVolleyForehandWinners")]
        public int TotalVolleyForehandWinners { get; set; }

        [Column("totalVolleyBackhandWinners")]
        public int TotalVolleyBackhandWinners { get; set; }

        [Column("totalVolleyForehandUnforcedErrors")]
        public int TotalVolleyForehandUnforcedErrors { get; set; }

        [Column("totalVolleyBackhandUnforcedErrors")]
        public int TotalVolleyBackhandUnforcedErrors { get; set; }

        [Column("totalSmashWinners")]
        public int TotalSmashWinners { get; set; }

        [Column("totalSmashErrors")]
        public int TotalSmashErrors { get; set; }

        [Column("totalPointsServing")]
        public int TotalPointsServing { get; set; }

        [Column("totalPointsReceiving")]
        public int TotalPointsReceiving { get; set; }

        [Column("totalFirstServeIn")]
        public int TotalFirstServeIn { get; set; }

        [Column("totalSecondServeIn")]
        public int TotalSecondServeIn { get; set; }

        [Column("totalFirstServePointsWon")]
        public int TotalFirstServePointsWon { get; set; }

        [Column("totalSecondServePointsWon")]
        public int TotalSecondServePointsWon { get; set; }

        [Column("totalDropshotWinners")]
        public int TotalDropshotWinners { get; set; }

        [Column("totalDropshotErrors")]
        public int TotalDropshotErrors { get; set; }

        [Column("totalGamesWon")]
        public int TotalGamesWon { get; set; }

        [Column("totalTournamentsWon")]
        public int TotalTournamentsWon { get; set; }

        public virtual Person Person { get; set; }
    }
}
