﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TpmDAO.Entity
{
    [Table("CategoriesInTournament")]
    public class CategoriesInTournament
    {
        [Key, Column("idTournament", Order = 0), ForeignKey("Tournament")]
        public int IdTournament { get; set; }

        [Key, Column("idCategory", Order = 1), ForeignKey("Category")]
        public int IdCategory { get; set; }

        [Column("idDraw")]
        public int? IdDraw { get; set; }

        [Column("prize")]
        public decimal Prize { get; set; }

        [Column("over")]
        public bool Over { get; set; }

        public virtual Tournament Tournament { get; set; }

        public virtual Category Category { get; set; }

        [NotMapped]
        public string Description { get; set; }

        [NotMapped]
        public Draw Draw { get; set; }

    }
}
