﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TpmDAO.Entity
{
    [Table("Tournament")]
    public class Tournament
    {
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        [Key, Column("idTournament")]
        public int IdTournament { get; set; }

        [Column("nameTournament")]
        [MaxLength(50)]
        public string NameTournament { get; set; }

        [Column("description")]
        [MaxLength(500)]
        public string Description { get; set; }

        [Column("startDate")]
        public DateTime StartDate { get; set; }

        [Column("endDate")]
        public DateTime EndDate { get; set; }

        [Column("enrollmentDeadline")]
        public DateTime EnrollmentDeadline { get; set; }

        [Column("enrollmentPrice")]
        public decimal EnrollmentPrice { get; set; }

        [Column("status")]
        public bool Status { get; set; } = true;

        [Column("tournamentPicture")]
        [MaxLength(200)]
        public string TournamentPicture { get; set; }

        [Column("idFacility"), ForeignKey("Facility")]
        public int IdFacility { get; set; }

        [Column("owner"), ForeignKey("Owner")]
        public int IdOwner { get; set; }    

        [NotMapped]
        public decimal Prize { get; set; }

        [NotMapped]
        public bool IsEnrolled { get; set; }

        [NotMapped]
        public int IdPerson { get; set; }

        [NotMapped]
        public bool Started { get; set; }

        [NotMapped]
        public string NameFacility { get; set; }

        [Column("over")]
        public bool Over { get; set; }

        public virtual Facility Facility { get; set; }

        public virtual Person Owner { get; set; }

        public virtual ICollection<CategoriesInTournament> CategoriesInTournament { get; set; }

        public virtual ICollection<Category> Categories { get; set; }

        public virtual ICollection<EnrolledPlayers> EnrolledPlayers { get; set; }

        public virtual ICollection<Umpire> Umpires { get; set; }

    }
}
