﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TpmDAO.Entity
{
    [Table("User")]
    public class User
    {
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        [Key, Column("idUser")]
        public int IdUser { get; set; }

        [Column("email")]
        [MaxLength(50)]
        public string Email { get; set; }

        [Column("password")]
        [MaxLength(500)]
        public string Password { get; set; }

        [Column("facebookId")]
        [MaxLength(50)]
        public string FacebookId { get; set; }

        [Column("profilePicture")]
        [MaxLength(500)]
        public string ProfilePicture { get; set; }

        [Column("idPerson"), ForeignKey("Person")]
        public int IdPerson { get; set; }

        [Column("token")]
        [MaxLength(500)]
        public string Token { get; set; }

        public virtual Person Person { get; set; }

        public virtual ICollection<UserRole> UserRoles { get; set; }

        public virtual ICollection<Message> Messages { get; set; }

        [NotMapped]
        public List<Role> Roles { get; set; }

    }
}
