﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Data.Entity.Validation;
using System.Linq;
using TpmDAO.Persistence;
using Utils;

namespace TpmDAO.Generic
{
    public class GenericDAO<T, K> where T : class
    {
        public static void Insert(T Entity)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    Con.Entry(Entity).State = EntityState.Added;
                    Con.SaveChanges();
                }
            }
            catch (DbEntityValidationException e)
            {
                throw new DbEntityValidationException(ExceptionTreatment.GetExceptionDetails(e));
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static void Update(T Entity)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    Con.Entry(Entity).State = EntityState.Modified;
                    Con.SaveChanges();
                }
            }
            catch (DbEntityValidationException e)
            {
                throw new DbEntityValidationException(ExceptionTreatment.GetExceptionDetails(e));
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static void Delete(T Entity)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    Con.Entry(Entity).State = EntityState.Deleted;
                    Con.SaveChanges();
                }
            }
            catch (DbEntityValidationException e)
            {
                throw new DbEntityValidationException(ExceptionTreatment.GetExceptionDetails(e));
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static T FindByKey(K Id)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.Set<T>().Find(Id);
                }
            }
            catch (DbEntityValidationException e)
            {
                throw new DbEntityValidationException(ExceptionTreatment.GetExceptionDetails(e));
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static List<T> FindAll()
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.Set<T>().ToList();
                }
            }
            catch (DbEntityValidationException e)
            {
                throw new DbEntityValidationException(ExceptionTreatment.GetExceptionDetails(e));
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }
    }
}
