﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TpmDAO.Entity;
using TpmDAO.Generic;
using Utils;

namespace TpmDAO.Persistence.Achievements
{
    public class UserAchievementsDAO : GenericDAO<UserAchievement, int>
    {
        public static void UpdateUserAchievements(Match Match)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    var TotalStats = new List<TotalStats>();
                    if (Match.IdTournament != null)
                        TotalStats.AddRange(Con.DbSetTotalStats.Include("Person.UserAchievements.Achievement").ToList().Where(x => x.IdPerson == Match.MatchStats.First().IdPerson && x.IdPerson == Match.MatchStats.Last().IdPerson).ToList());
                    else
                        TotalStats.AddRange(Con.DbSetTotalStats.Include("Person.UserAchievements.Achievement").ToList().Where(x => x.IdPerson == Match.MatchStats.First().IdPerson).ToList());
                    var Achievements = AchievementsDAO.FindAll();
                    int i = 0;
                    foreach (var item in TotalStats)
                    {
                        i++;
                        if (Match.IdTournament != null || (Match.IdTournament == null && i == 1))
                        {
                            var UserLockedAchievemnts = Achievements.Where(x => item.Person.UserAchievements.Select(a => a.IdAchievement).ToList().Contains(x.IdAchievement)).ToList();
                            foreach (var achievement in UserLockedAchievemnts)
                            {
                                if (CheckUnlockment(achievement, item))
                                {
                                    UserAchievement UserAchievement = new UserAchievement();
                                    UserAchievement.IdAchievement = achievement.IdAchievement;
                                    UserAchievement.IdPerson = item.IdPerson;
                                    UserAchievement.UnlockDate = DateTime.Today;
                                    UserAchievementsDAO.Insert(UserAchievement);
                                }
                            }
                        }
                    }
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static List<Achievement> GetAchievementsByPerson(int IdPerson)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    var UserAchievements = Con.DbSetUserAchievement.Where(x => x.IdPerson == IdPerson).ToList();
                    var Achievements = AchievementsDAO.FindAll();
                    foreach(var item in UserAchievements)
                    {
                        Achievements[item.IdAchievement - 1].Unlocked = true;
                    }
                    return Achievements;
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static bool CheckUnlockment(Achievement Achievement, TotalStats TotalStats)
        {
            switch (Achievement.IdAchievement)
            {
                case 1:
                    return true;
                case 2:
                    if (TotalStats.TotalWins >= 1)
                        return true;
                    else
                        return false;
                case 3:
                    if (TotalStats.TotalTournamentsWon >= 1)
                        return true;
                    else
                        return false;
                case 4:
                    if ((TotalStats.TotalWins + TotalStats.TotalLoses) >= 10)
                        return true;
                    else
                        return false;
                case 5:
                    if (TotalStats.TotalWins >= 10)
                        return true;
                    else
                        return false;
                case 6:
                    if (TotalStats.TotalTournamentsWon >= 2)
                        return true;
                    else
                        return false;
                case 7:
                    if ((TotalStats.TotalWins + TotalStats.TotalLoses) >= 100)
                        return true;
                    else
                        return false;
                case 8:
                    if (TotalStats.TotalWins >= 100)
                        return true;
                    else
                        return false;
                case 9:
                    if (TotalStats.TotalTournamentsWon >= 10)
                        return true;
                    else
                        return false;
                case 10:
                    if (TotalStats.TotalAces >= 10)
                        return true;
                    else
                        return false;
                case 11:
                    if (TotalStats.TotalAces >= 100)
                        return true;
                    else
                        return false;
                case 12:
                    if (TotalStats.TotalAces >= 500)
                        return true;
                    else
                        return false;
                case 13:
                    if (TotalStats.TotalDropshotWinners >= 1)
                        return true;
                    else
                        return false;
                case 14:
                    if (TotalStats.TotalDropshotWinners >= 10)
                        return true;
                    else
                        return false;
                case 15:
                    if (TotalStats.TotalDropshotWinners >= 20)
                        return true;
                    else
                        return false;
                case 16:
                    if (TotalStats.TotalPointsWon >= 100)
                        return true;
                    else
                        return false;
                case 17:
                    if (TotalStats.TotalPointsWon >= 500)
                        return true;
                    else
                        return false;
                case 18:
                    if (TotalStats.TotalPointsWon >= 1000)
                        return true;
                    else
                        return false;
                default:
                    return false;
            }
        }
    }
}
