﻿using System;
using System.Linq;
using TpmDAO.Entity;
using TpmDAO.Generic;
using Utils;

namespace TpmDAO.Persistence
{
    public class AddressDAO : GenericDAO<Address, int>
    {
        public static City FindCityByName(string Name)
        {
            try
            {
                using(Connection Con = new Connection())
                {
                    return Con.DbSetCity.Where(x => x.NameCity.Equals(Name)).FirstOrDefault();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));            }
        }

        public static State FindStateByUf(string Uf)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetState.Where(x => x.Uf.Equals(Uf)).FirstOrDefault();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

    }
}
