﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data.Entity;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TpmDAO.Entity;
using System.Data.Entity.Infrastructure;

namespace TpmDAO.Persistence
{
    class Connection : DbContext
    {
        public Connection() 
            : base(ConfigurationManager.ConnectionStrings["TPM"].ConnectionString)
        {
            this.Configuration.LazyLoadingEnabled = false;
            this.Configuration.ProxyCreationEnabled = false;
        }

        #region User

        public DbSet<User> DbSetUser { get; set; }

        #endregion

        #region Role

        public DbSet<Role> DbSetRole { get; set; }

        public DbSet<UserRole> DbSetUserRole { get; set; }

        #endregion

        #region Address

        public DbSet<State> DbSetState { get; set; }

        public DbSet<Address> DbSetAddress { get; set; }

        public DbSet<City> DbSetCity { get; set; }

        #endregion

        #region Person

        public DbSet<Hand> DbSetHand { get; set; }

        public DbSet<Person> DbSetPerson { get; set; }

        public DbSet<TotalStats> DbSetTotalStats { get; set; }

        #endregion

        #region Achievement

        public DbSet<Achievement> DbSetAchievement { get; set; }

        public DbSet<UserAchievement> DbSetUserAchievement { get; set; }

        #endregion

        #region Facility

        public DbSet<FacilityPicture> DbSetFacilityPicture { get; set; }

        public DbSet<Facility> DbSetFacility { get; set; }

        #endregion

        #region Category

        public DbSet<CategoryAge> DbSetCategoryAge { get; set; }

        public DbSet<CategoryGender> DbSetCategoryGender { get; set; }

        public DbSet<CategoryClass> DbSetCategoryClass { get; set; }

        public DbSet<Category> DbSetCategory { get; set; }

        #endregion

        #region Match

        public DbSet<Round> DbSetRound { get; set; }

        public DbSet<Surface> DbSetSurface { get; set; }

        public DbSet<TpmDAO.Entity.Match> DbSetMatch { get; set; }

        public DbSet<Stats> DbSetStats { get; set; }

        #endregion

        #region Tournament

        public DbSet<Tournament> DbSetTournament { get; set; }

        public DbSet<CategoriesInTournament> DbSetCategoriesInTournament { get; set; }

        public DbSet<EnrolledPlayers> DbSetEnrolledPlayers { get; set; }

        public DbSet<Umpire> DbSetUmpire { get; set; }

        public DbSet<Draw> DbSetDraw { get; set; }
        #endregion

        #region Message

        public DbSet<Message> DbSetMessage { get; set; }

        #endregion

        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
        }

    }
}
