﻿using System;
using System.Collections.Generic;
using System.Linq;
using TpmDAO.Entity;
using TpmDAO.Generic;
using Utils;

namespace TpmDAO.Persistence
{
    public class FacilityDAO : GenericDAO<Facility, int>
    {
        public static List<Facility> FindAllComplete(int IdUser = 0)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    if (IdUser != 0)
                        return Con.DbSetFacility.Include("Address.City.State").Include("Pictures").Where(x => x.Owner == IdUser).ToList();
                    else
                        return Con.DbSetFacility.Include("Address.City.State").Include("Pictures").ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static Facility FindByKeyComplete(int IdFacility)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetFacility.Include("Address.City.State").Include("Pictures").Where(x => x.IdFacility == IdFacility).FirstOrDefault();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static Facility FindByTournament(int IdTournament)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetTournament.Include("Tournament.Facility.Address").Where(x => x.IdTournament == IdTournament).Select(x => x.Facility).FirstOrDefault();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }
    }
}
