﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TpmDAO.Entity;
using TpmDAO.Generic;
using Utils;

namespace TpmDAO.Persistence
{
    public class MatchDAO : GenericDAO<Entity.Match, int>
    {


        public static List<Match> GetAllMatchesInPeriod(int IdOwner)
        {
            try
            {
                using(Connection Con = new Connection())
                {
                    var Result = new List<Match>();
                    if (IdOwner != 0)
                        Result = Con.DbSetMatch.Include("Tournament").Include("MatchStats.Person").Include("Draw").Include("Round").Where(x => x.Tournament.IdOwner == IdOwner).ToList();
                    else
                        Result = Con.DbSetMatch.Include("Tournament").Include("MatchStats.Person").Include("Draw").Include("Round").ToList();
                    return Result.Where(x => x.DateMatch.HasValue && x.DateMatch.Value.Date >= DateTime.Now.Date).ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static List<Match> GetMatchesForUmpire(CategoriesInTournament CategoriesInTournament)
        {
            try
            {
                using (Connection Con = new Connection())
                {

                    var Result = Con.DbSetMatch.Include("MatchStats.Person").Include("Round").Include("Draw").Where(x => !x.Over && x.MatchStats.Count() == 2 && x.Draw.IdTournament == CategoriesInTournament.IdTournament && x.Draw.IdCategory == CategoriesInTournament.IdCategory).ToList();

                    foreach (var item in Result)
                    {
                        item.Draw = null;
                        item.Round.Matches = null;
                    }
                    return Result;
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static List<Match> GetSimpleMatches(Person Person)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    var Result = Con.DbSetMatch.Include("MatchStats.Person").Where(x => x.IdTournament == null && x.MatchStats.Where(p => p.IdPerson == Person.IdPerson).FirstOrDefault() != null).ToList();
                    foreach (var item in Result)
                    {
                        if (item.MatchStats.First().IdPerson != Person.IdPerson)
                        {
                            item.MatchStats.Reverse();
                        }
                    }

                    return Result;
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }
    }
}