﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TpmDAO.Entity;
using TpmDAO.Generic;

namespace TpmDAO.Persistence
{
    public class TotalStatsDAO : GenericDAO<TotalStats, int>
    {
        public static void UpdateTotalStats(ref Match Match)
        {
            try
            {
                int i = 0;
                foreach (var item in Match.MatchStats)
                {
                    i++;
                    if (Match.IdTournament != null || (Match.IdTournament == null && i == 1))
                    {
                        var TotalStats = FindByKey(item.IdPerson);
                        TotalStats.TotalAces += item.Aces;
                        TotalStats.TotalBackhandUnforcedErrors += item.BackhandUnforcedErrors;
                        TotalStats.TotalBackhandWinners += item.BackhandWinners;
                        TotalStats.TotalDoubleFaults += item.DoubleFaults;
                        TotalStats.TotalDropshotErrors += item.DropshotErrors;
                        TotalStats.TotalDropshotWinners += item.DropshotWinners;
                        TotalStats.TotalFirstServeIn += item.TotalFirstServeIn;
                        TotalStats.TotalFirstServePointsWon += item.TotalFirstServePointsWon;
                        TotalStats.TotalForcedErrors += item.ForcedErrors;
                        TotalStats.TotalForehandUnforcedErrors += item.ForehandUnforcedErrors;
                        TotalStats.TotalForehandWinners += item.ForehandWinners;
                        TotalStats.TotalGamesWon += (item.FirstSetGames + item.SecondSetGames + item.ThirdSetGames);
                        TotalStats.TotalPointsLost += item.TotalPointsLost;
                        TotalStats.TotalPointsReceiving += item.TotalPointsReceiving;
                        TotalStats.TotalPointsServing += item.TotalPointsServing;
                        TotalStats.TotalPointsWon += item.TotalPointsWon;
                        TotalStats.TotalSecondServeIn += item.TotalSecondServeIn;
                        TotalStats.TotalSecondServePointsWon += item.TotalSecondServePointsWon;
                        TotalStats.TotalSmashErrors += item.SmashErrors;
                        TotalStats.TotalSmashWinners += item.SmashWinners;
                        TotalStats.TotalVolleyBackhandUnforcedErrors += item.VolleyBackhandUnforcedErrors;
                        TotalStats.TotalVolleyBackhandWinners += item.VolleyBackhandWinners;
                        TotalStats.TotalVolleyForehandUnforcedErrors += item.VolleyForehandUnforcedErrors;
                        TotalStats.TotalVolleyForehandWinners += item.VolleyForehandWinners;
                        TotalStats.TotalWins += item.Result.Equals("W") ? 1 : 0;
                        TotalStats.TotalLoses += item.Result.Equals("L") ? 1 : 0;
                        TotalStats.TotalTournamentsWon += Match.IdRound == 1 && item.Result.Equals("W") ? 1 : 0;

                        Update(TotalStats);
                    }
                }
            }
            catch (Exception e)
            {
                throw new Exception(Utils.ExceptionTreatment.GetExceptionDetails(e));
            }
        }
    }
}
