﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TpmDAO.Entity;
using Utils;

namespace TpmDAO.Persistence
{
    public class ReportDAO
    {

        public static List<User> ReportUsers(DateTime? StartDate, DateTime? EndDate, int UserType)
        {
            try
            {

                using (Connection Con = new Connection())
                {
                    var Users = new List<User>();

                    if (StartDate.HasValue && EndDate.HasValue)
                        return Con.DbSetUser.Include("Person.Address.City.State").Include("UserRoles")
                                .Where(x => x.UserRoles.Where(a => (UserType != 0 ? UserType == 1 ? a.IdRole != 1 : a.IdRole == UserType : a.IdRole != 1) && a.RequisitionDate >= StartDate.Value
                                && a.RequisitionDate <= EndDate.Value).FirstOrDefault() != null).ToList();
                    else if (StartDate.HasValue)
                        return Con.DbSetUser.Include("Person.Address.City.State").Include("UserRoles")
        .Where(x => x.UserRoles.Where(a => (UserType != 0 ? UserType == 1 ? a.IdRole != 1 : a.IdRole == UserType : a.IdRole != 1) && a.RequisitionDate >= StartDate.Value
        && a.RequisitionDate <= DateTime.Now).FirstOrDefault() != null).ToList();
                    else
                        return Con.DbSetUser.Include("Person.Address.City.State").Include("UserRoles").Where(x => x.UserRoles.Where(a => a.IdRole != 1 && (UserType > 1 ? a.IdRole == UserType : 1 == 1)).FirstOrDefault() != null).ToList();
                }

            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static List<Facility> ReportFacilities(int Owner, int State, int City)
        {
            try
            {

                using (Connection Con = new Connection())
                {

                    return Con.DbSetFacility.Include("Address.City.State").Where(x => Owner != 0 ? x.Owner == Owner : 1 == 1 && (City != 0 ? x.Address.City.IdCity == City : 1 == 1
                    && State != 0 ? x.Address.City.IdState == State : 1 == 1)).ToList();

                }

            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static List<Tournament> ReportTournaments(int Owner, DateTime? StartDate, DateTime? EndDate)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetTournament.Include("Facility").Include("EnrolledPlayers")
                        .Where(x => Owner != 0 ? x.IdOwner == Owner : 1 == 1 && (StartDate.HasValue ? x.StartDate >= StartDate.Value : 1 == 1) && (EndDate.HasValue ? x.StartDate <= EndDate.Value : 1 == 1)).ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static List<User> ReportPremiumUsers(int Year)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetUser.Include("UserRoles").Include("Person").ToList().Where(x => x.UserRoles.Where(a => a.IdRole == 2 &&
                    a.RequisitionDate.Date.Year == Year).FirstOrDefault() != null).Where(b => b.UserRoles.Where(a => a.IdRole == 1).FirstOrDefault() == null).ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }
    }
}
