﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TpmDAO.Entity;
using TpmDAO.Generic;

namespace TpmDAO.Persistence
{
    public class UserRoleDAO : GenericDAO<UserRole, int>
    {
        public static List<UserRole> GetNewRequests()
        {
            try
            {
                using(Connection Con = new Connection())
                {
                    return Con.DbSetUserRole.Include("User").Where(x => x.IsNew).ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

        public static List<UserRole> FindRolesByUser(int IdUser)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetUserRole.Where(x => x.IdUser == IdUser).ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

        public static UserRole GetRequestByUser(int IdUser)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetUserRole.Where(x => x.IdUser == IdUser && x.IdRole == 2).FirstOrDefault();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }
    }
}
