﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TpmDAO.Entity;
using TpmDAO.Generic;
using Utils;

namespace TpmDAO.Persistence
{
    public class DrawDAO : GenericDAO<Draw, int>
    {
        public static Draw FindByTournament(int IdTournament)
        {
            try
            {
                using(Connection Con = new Connection())
                {
                    return Con.DbSetDraw.FirstOrDefault(x => x.IdTournament == IdTournament);
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static Draw FindByTournamentAndCategory(int IdTournament, int IdCategory)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetDraw.Include("Matches.MatchStats.Person").Include("Matches.Round").Include("Matches.Surface").FirstOrDefault(x => x.IdTournament == IdTournament && x.IdCategory == IdCategory);
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static Draw FindByKeyComplete(int IdDraw)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetDraw.Include("Matches.MatchStats.Person").Include("Matches.Round").FirstOrDefault(x => x.IdDraw == IdDraw);
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }
    }
}
