﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TpmDAO.Entity;
using TpmDAO.Generic;
using Utils;

namespace TpmDAO.Persistence
{
    public class EnrolledPlayersDAO : GenericDAO<EnrolledPlayers, int >
    {

        public static EnrolledPlayers FindPlayerEnrolled(int IdPerson, int IdTournament)
        {
            try
            {
                using(Connection Con = new Connection())
                {
                    return Con.DbSetEnrolledPlayers.Where(x => x.IdPerson == IdPerson && x.IdTournament == IdTournament).FirstOrDefault();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static List<EnrolledPlayers> FindLastEnrollments(int IdOwner)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    var Result = Con.DbSetEnrolledPlayers.Include("Tournament.Facility").Include("Person").Where(x => x.Tournament.IdOwner == IdOwner).ToList();

                    return Result.Where(x => x.Tournament.EndDate.Date >= DateTime.Now.Date).OrderByDescending(x => x.EnrollmentDate).ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }
    }
}
