﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TpmDAO.Entity;
using TpmDAO.Generic;

namespace TpmDAO.Persistence
{
    public class UmpireDAO : GenericDAO<Umpire, int>
    {

        public static List<Umpire> FindByTournament(int IdTournament)
        {
            try
            {
                using(Connection Con = new Connection())
                {
                    return Con.DbSetUmpire.Where(x => x.IdTournament == IdTournament)
                        .Join(Con.DbSetPerson, u => u.IdPerson, p => p.IdPerson, (u, p) => new { u, p })
                        .Join(Con.DbSetUser, u => u.u.IdPerson, us => us.IdPerson, (u, us) => new { u, us})
                        .ToList()
                        .Select(x => new Umpire
                        {
                            Email = x.us.Email,
                            IdPerson = x.u.u.IdPerson,
                            IdTournament = x.u.u.IdTournament,
                            Name = x.u.p.FullName
                        }).ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

    }
}
