﻿using System;
using System.Collections.Generic;
using System.Linq;
using TpmDAO.Entity;
using TpmDAO.Generic;
using Utils;

namespace TpmDAO.Persistence
{
    public class UserDAO : GenericDAO<User, int>
    {
        public static User Autenticate(string Login, string Password)
        {
            try
            {
                using(Connection Con = new Connection())
                {
                    return Con.DbSetUser.Include("Person").Include("UserRoles").FirstOrDefault(x => x.Email.Equals(Login) && x.Password.Equals(Password));
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static User FindByEmail(string Email)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetUser.Include("Person").Include("UserRoles").FirstOrDefault(x => x.Email.Equals(Email));
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static User FindByEmailComplete(string Email)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetUser.Include("Person.Address.City.State").Include("Person.Hand").Include("UserRoles").FirstOrDefault(x => x.Email.Equals(Email));
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static User FindByKeyComplete(int IdUser)
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetUser.Include("Person.Address.City.State").Include("Person.Hand").Include("UserRoles").FirstOrDefault(x => x.IdUser == IdUser);
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static User FindUserByToken(string Token)
        {
            try
            {
                using(Connection Con = new Connection())
                {
                    return Con.DbSetUser.Include("Person").Where(x => x.Token.Equals(Token)).FirstOrDefault();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static List<User> FindAllComplete()
        {
            try
            {
                using (Connection Con = new Connection())
                {
                    return Con.DbSetUser.Include("Person.Address.City.State").Include("UserRoles").Where(x => !x.UserRoles.Contains(x.UserRoles.Where(a => a.IdRole == 1).FirstOrDefault())).ToList();
                }
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }
    }
}