﻿using System.Web;
using System.Web.Optimization;

namespace TpmMVC
{
    public class BundleConfig
    {
        // For more information on bundling, visit https://go.microsoft.com/fwlink/?LinkId=301862
        public static void RegisterBundles(BundleCollection bundles)
        {
            #region Scripts

            #region Global
            bundles.Add(new ScriptBundle("~/bundles/Global")
                .Include("~/Scripts/Global/jquery-3.2.1.js")
                .Include("~/Scripts/Global/bootstrap*")
                .Include("~/Scripts/Global/jquery-ui.js")
                .Include("~/Scripts/Global/respond.js")
                .Include("~/Scripts/Global/modernizr-*")
                .Include("~/Scripts/Global/jquery.validate*")
                .Include("~/Scripts/Global/Custom/Calendar/jquery.eventCalendar.js")
                .Include("~/Scripts/Global/alertify.js*")
                .Include("~/Scripts/Global/TpmScript.js")
                .Include("~/Scripts/Global/jquery.mask.js")
                .Include("~/Scripts/Global/DataTables/dataTables.jquery.js")
                .Include("~/Scripts/Global/DataTables/dataTables.responsive.js")
                .Include("~/Scripts/Global/DataTables/dataTables.select.min.js")
                .Include("~/Scripts/Global/DataTables/dataTables.responsive.bootstrap.min.js")
                .Include("~/Scripts/Global/Custom/moment.js")
                .Include("~/Scripts/Global/Custom/Gallery.js")
                .Include("~/Scripts/Global/Cookie/jquery.cookie.js")
                );

            #endregion

            #region Modal

            bundles.Add(new ScriptBundle("~/bundles/Modal")
            .Include("~/Scripts/Modal/ModalScripts.js")
            );

            #endregion

            #region Adm

            bundles.Add(new ScriptBundle("~/bundles/Adm")
                .Include("~/Areas/RestrictedArea/Scripts/Adm/AdmScript.js")
                );

            #endregion

            #region User

            bundles.Add(new ScriptBundle("~/bundles/User")
                .Include("~/Areas/RestrictedArea/Scripts/User/UserScript.js")
                );

            #endregion

            #region Facility

            bundles.Add(new ScriptBundle("~/bundles/Facility")
                .Include("~/Areas/RestrictedArea/Scripts/Facility/Facility.js")
                );

            #endregion

            #region Tournament

            bundles.Add(new ScriptBundle("~/bundles/Tournament")
                .Include("~/Areas/RestrictedArea/Scripts/Tournament/TournamentScript.js")
                );

            #endregion

            #region Bracket

            bundles.Add(new ScriptBundle("~/bundles/Bracket")
                    .Include("~/Scripts/Global/Custom/Bracket/brackets.js")
                    );

            #endregion

            #region Reports

            bundles.Add(new ScriptBundle("~/bundles/Report")
                .Include("~/Areas/RestrictedArea/Scripts/Report/Report.js")
                );

            #endregion

            #region Message

            bundles.Add(new ScriptBundle("~/bundles/Message")
        .Include("~/Areas/RestrictedArea/Scripts/Message/Message.js")
        );

            #endregion

            #region Premium

            bundles.Add(new ScriptBundle("~/bundles/Premium")
            .Include("~/Areas/RestrictedArea/Scripts/Premium/Premium.js")
            );

            #endregion

            #endregion

            #region Styles

            bundles.Add(new StyleBundle("~/Content/Style")
                .Include("~/Content/bootstrap.css")
                .Include("~/Content/font-awesome.css")
                .Include("~/Content/alertify/alertify.css")
                .Include("~/Content/jquery-ui*")
                .Include("~/Content/site.css")
                .Include("~/Content/alertify/themes/bootstrap*")
                .Include("~/Content/alertify/themes/default*")
                .Include("~/Content/alertify/themes/semantic*")
                .Include("~/Content/Menu.css")
                .Include("~/Content/DataBallon.css")
                .Include("~/Content/DataTables/dataTables.jquery.css")
                .Include("~/Content/DataTables/dataTables.bootstrap.css")
                .Include("~/Content/DataTables/dataTables.select.min.css")
                .Include("~/Content/DataTables/dataTables.responsive.bootstrap.min.css")
                .Include("~/Content/Gallery/Gallery.css")
                .Include("~/Content/bracket/jquery.bracket.min.css")
                .Include("~/Content/Calendar/event*")
                .Include("~/Content/Calendar/paragridma*")
                );
            #endregion

            //BundleTable.EnableOptimizations = true;

        }
    }
}
