﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using TpmMVC.CustomValidators;
using TpmMVC.Models;
using TpmMVC.Util.CustomValidators;

namespace TpmMVC.Areas.RestrictedArea.Models.Facility
{
    public class FacilityViewModel
    {

        public int? IdFacility { get; set; }

        [Required(ErrorMessage = "Informe o Nome!")]
        [DisplayName("Nome")]
        public string Name { get; set; }

        [Required(ErrorMessage = "Informe o Telefone!")]
        [DisplayName("Telefone")]
        public string Phone { get; set; }

        [Required(ErrorMessage = "Forneça uma descrição!")]
        [DisplayName("Descrição")]
        public string Descript { get; set; }

        [Required(ErrorMessage = "Informe o E-mail!")]
        [EmailAddress(ErrorMessage = "E-Mail inválido!")]
        public string Email { get; set; }

        [DropDownValidator(ErrorMessage = "Informe o Proprietário!")]
        [DisplayName("Proprietário")]
        public string  IdOwner { get; set; }

        [Required(ErrorMessage = "Informe o Cep!")]
        [MaxLength(9, ErrorMessage = "CEP inválido")]
        [DisplayName("CEP")]
        public string Cep { get; set; }

        [Required(ErrorMessage = "Informe a rua!")]
        [DisplayName("Logradouro")]
        public string Street { get; set; }

        [DisplayName("Nº")]
        public int? Number { get; set; }

        [DisplayName("Complemento")]
        public string Detail { get; set; }

        [Required(ErrorMessage = "Informe o bairro!")]
        [DisplayName("Bairro")]
        public string Neighborhood { get; set; }

        [DropDownValidator(ErrorMessage = "Informe a cidade!")]
        [DisplayName("Cidade")]
        public string City { get; set; }

        [DropDownValidator(ErrorMessage = "Informe o estado!")]
        [DisplayName("Estado")]
        public string State { get; set; }

        [DisplayName("Imagens")]
        [FileValidator(ErrorMessage = "Arquivo Inválido!")]
        public List<HttpPostedFileBase> FacilityPrictures { get; set; }

        public int? IdAddress { get; set; }

        public bool? Status { get; set; }

        public List<string> Urls { get; set; }

    }
}