﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using TpmDAO.Entity;
using TpmMVC.Util.CustomValidators;

namespace TpmMVC.Areas.RestrictedArea.Models.Tournament
{
    public class TournamentViewModel
    {
        public int IdTournament { get; set; }

        [Required(ErrorMessage = "Informe o nome!")]
        [DisplayName("Nome")]
        public string NameTournament { get; set; }

        [Required(ErrorMessage = "Informe a descrição!")]
        [DisplayName("Descrição")]
        public string Description { get; set; }

        [Required(ErrorMessage = "Informe a data inicial!")]
        [DateValidator(ErrorMessage = "Selecione uma data válida!")]
        [DisplayName("Data Inicial")]
        public DateTime StartDate { get; set; }

        [Required(ErrorMessage = "Informe a data final!")]
        [DateEndTournamentValidator(ErrorMessage = "Data Final inválida")]
        [DisplayName("Data Final")]
        public DateTime EndDate { get; set; }

        [Required(ErrorMessage = "Informe a data limite para inscrição!")]
        [DateTournamentDeadline(ErrorMessage = "Data limite inválida!")]
        [DisplayName("Data Limite Inscrição")]
        public DateTime EnrollmentDeadline { get; set; }

        [Required(ErrorMessage = "Informe o preço de inscrição!")]
        [DisplayName("Preço inscrição")]
        public decimal EnrollmentPrice { get; set; }

        [DisplayName("Foto")]
        [FileValidator(ErrorMessage = "Arquivo Inválido!")]
        public HttpPostedFileBase TournamentPicture { get; set; }

        [DropDownValidator(ErrorMessage = "Informe o Realizador")]
        [DisplayName("Realizador")]
        public string IdOwner { get; set; }

        [DropDownValidator(ErrorMessage = "Informe o local")]
        [DisplayName("Local")]
        public string IdFaciity { get; set; }

        #region Edit/Show


        public string Picture { get; set; }

        public List<EnrolledPlayersGridViewModel> TournamentPlayers { get; set; }

        public List<UmpireGridViewModel> TournamentUmpires { get; set; }

        public List<CategoryGridViewModel> TournamentCategories { get; set; }

        public string CategoriesJson { get; set; }

        public string UmpiresJson { get; set; }

        #endregion


    }
}