﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using TpmMVC.Util.CustomValidators;

namespace TpmMVC.Areas.RestrictedArea.Models.User
{
    public class UserViewModel
    {
        [Required(ErrorMessage = "Informe o nome!")]
        [DisplayName("Nome")]
        public string Name { get; set; }

        [Required(ErrorMessage = "Informe o sobrenome!")]
        [DisplayName("Sobrenome")]
        public string LastName { get; set; }

        [Required(ErrorMessage = "Informe o email!")]
        [EmailAddress(ErrorMessage = "Email inválido!")]
        [DisplayName("E-mail")]
        public string Email { get; set; }

        [Required(ErrorMessage = "Informe o telefone!")]
        [MaxLength(15, ErrorMessage = "Telefone inválido")]
        [DisplayName("Telefone")]
        public string Tel { get; set; }

        [Required(ErrorMessage = "Informe a data de nascimento!")]
        [DisplayName("Nascimento")]
        public DateTime BirthDate { get; set; }

        [Required(ErrorMessage = "Informe o sexo!")]
        [DisplayName("Sexo")]
        public string Gender { get; set; }

        [DisplayName("Foto de Perfil")]
        public HttpPostedFileBase Photo { get; set; }

        [DropDownValidator(ErrorMessage = "informe a mão!")]
        [DisplayName("Mão")]
        public string IdHand { get; set; }

        [DropDownValidator(ErrorMessage = "informe sua classe!")]
        [DisplayName("Classe")]
        public string IdClass { get; set; }

        [Required(ErrorMessage = "Informe o Cep!")]
        [MaxLength(9, ErrorMessage = "CEP inválido")]
        [DisplayName("CEP")]
        public string Cep { get; set; }

        [Required(ErrorMessage = "Informe a rua!")]
        [DisplayName("Logradouro")]
        public string Street { get; set; }

        [DisplayName("Nº")]
        public int? Number { get; set; }

        [DisplayName("Complemento")]
        public string Detail { get; set; }

        [Required(ErrorMessage = "Informe o bairro!")]
        [DisplayName("Bairro")]
        public string Neighborhood { get; set; }

        [DropDownValidator(ErrorMessage = "Informe a cidade!")]
        [DisplayName("Cidade")]
        public int City { get; set; }

        [DropDownValidator(ErrorMessage = "Informe o estado!")]
        [DisplayName("Estado")]
        public int State { get; set; }

        public string BirthDateFormat { get; set; }

        public string ProfilePicture { get; set; }

        [DisplayName("Acesso Premium")]
        public bool PremiumAccess { get; set; }

        [DisplayName("Acesso Básico")]
        public bool UserAccess { get; set; }

        public int IdUser { get; set; }

        public int IdPerson { get; set; }
    }
}