﻿$(document).ready(function (e) {

    ShowSpinner();

    Initializefields();

    setTimeout(function () {
        InitializeDataTable();
    }, 100);

    $('#table-Requests').on('click', '#btnInfoRequest', function (e) {
        ShowSpinner();
        let data = GetDataFromTable('#table-Requests', $(this));
        OpenModalWithParam('/RestrictedArea/Home/GetUserInfo', 'modal-lg', data.IdUser);
        setTimeout(function () {
            HideSpinner();
        }, 100);
    });

    $('#table-Requests').on('click', '#btnAcceptRequest', function (e) {
        let data = GetDataFromTable('#table-Requests', $(this));
        alertify.confirm('Aprovar Requisição', 'Tem certeza que deseja aprovar esta requisição?', function (e) {
            location.href = '/RestrictedArea/Home/AcceptRequest?IdUser=' + data.IdUser;
        }, function (e) {

            });
    });

    $('#table-Requests').on('click', '#btnRefuseRequest', function (e) {
        let data = GetDataFromTable('#table-Requests', $(this));
        alertify.confirm('Negar Requisição', 'Tem certeza que deseja negar esta requisição?', function (e) {
            location.href = '/RestrictedArea/Home/RefuseRequest?IdUser=' + data.IdUser;
        }, function (e) {

        });
    });
});

function Initializefields() {
    $('.menu-Home').css('background-color', 'rgba(27, 94, 32, 0.41)');
}

function InitializeDataTable() {

    var columnkeys = [];
    var newTable = '<thead><tr><th>IdUser</th><th>Usuário</th><th>E-mail</th><th>Data Cadastro</th><th>Data de Requisição</th><th></th></tr></thead>';

    $.ajax({
        url: '/RestrictedArea/Home/GetNewRequests',
        method: 'GET',
        dataType: 'json',
        success: function (content) {
            if (content && content.hasOwnProperty('Type') && content.Tipo === 2) {
                alertify.error(content.Message);
            }
            else {
                if (content.length > 0) {
                    var a = 0;
                    $.each(content[0], function (key, value) {
                        columnkeys[a] = { data: key };
                        a++;
                    });
                } else {
                    for (var i = 0; i < 6; i++)
                        columnkeys[i] = { data: i };
                }
                $('#table-Requests').append(newTable);
                $('#table-Requests').DataTable({
                    responsive: true,
                    //select: true,
                    data: content,
                    "columns": columnkeys,
                    "columnDefs": [{ "className": "dt-center", "targets": "_all" },
                        {
                            type: 'date-euro', "targets": [3]
                        },
                    {
                        "targets": 0,
                        "searchable": false,
                        'orderable': false,
                        "visible": false
                    },
                    {
                        "targets": 5,
                        "searchable": false,
                        'orderable': false,
                        'render': function (data, type, full, meta) {
                            return '<button id="btnInfoRequest" class="btn-circle btn-dataTable" data-balloon="Informações" data-balloon-pos="up"> <i class="fa fa-info-circle fa-2x" aria-hidden="true"></i></button>' +
                                '<button id= "btnAcceptRequest" class="btn-circle btn-dataTable" data-balloon="Aprovar" data-balloon-pos="up"> <i class="fa fa-check-circle fa-2x" aria-hidden="true"></i></button >' +
                                '<button id= "btnRefuseRequest" class="btn-circle btn-dataTable" data-balloon="Recusar" data-balloon-pos="up"> <i class="fa fa-times-circle fa-2x" aria-hidden="true"></i></button >';
                        }
                    }
                    ]
                });
            }
            HideSpinner();
        }
    });
}