﻿$(document).ready(function (e) {

    ShowSpinner();

    Initialize();

    setTimeout(function () {
        InitializeDataTable();
    }, 100);

    $('#table-Facilities').on('click', '#btnInfoFacility', function (e) {
        let data = GetDataFromTable('#table-Facilities', $(this));
        OpenModalWithParam('/RestrictedArea/Facility/GetFacilityInfo', 'modal-md', data.IdFacility);
        $('.hideAddress').removeClass('hide');
        $('#formRegisterFacility #btnCep').addClass('hide');
        $('#formRegisterFacility :input').attr('disabled', true);
        if ($('#formRegisterFacility').find('.pgwSlideshow').length) {
            $('#formRegisterFacility').find('.pgwSlideshow').pgwSlideshow();
            $('#formRegisterFacility').find('.pgwSlideshow .ps-current img').css('height', '-webkit-fill-available');
        }
    });

    $('#table-Facilities').on('click', '#btnEditFacility', function (e) {

        let data = GetDataFromTable('#table-Facilities', $(this));
        let FacilityData = GetJson('/RestrictedArea/Facility/GetFacilityData', data.IdFacility);
        ShowSpinner();
        $('.container-slider').empty();
        $('formUpdateFacility').trigger('reset');
        setTimeout(function () {
            FillFacilityData(FacilityData);
        }, 100);
    });

    $('#table-Facilities').on('click', '#btnRemoveFacility', function (e) {
        let data = GetDataFromTable('#table-Facilities', $(this));
        alertify.confirm('Desativar Instação', 'Tem certeza que deseja desativar essa instação?', function (e) {
            location.href = '/RestrictedArea/Facility/RemoveFacility?IdFacility=' + data.IdFacility;
        }, function (e) {

        });
    });

    $('#table-Facilities').on('click', '#btnActiveFacility', function (e) {
        let data = GetDataFromTable('#table-Facilities', $(this));
        alertify.confirm('Reativar Instação', 'Tem certeza que deseja reativar essa instação?', function (e) {
            location.href = '/RestrictedArea/Facility/ReactiveFacility?IdFacility=' + data.IdFacility;
        }, function (e) {

        });
    });

    $('#btnNewFacility').on('click', function (e) {
        e.preventDefault();
        ShowSpinner();
        setTimeout(function () {
            OpenModal('/RestrictedArea/Facility/Create', 'modal-md');
            HideSpinner();
        }, 1000);
    });

    $('#formUpdateFacility').on('submit', function (e) {
        e.preventDefault();
        ShowSpinner();
        let fdata = new FormData($(this)[0]);
        let form = $(this).valid();
        setTimeout(function () {
            if (!form)
                HideSpinner();
            else {

                let data = SubmitFormwithDataTable('/RestrictedArea/Facility/UpdateFacilityAsync', fdata, e);
                if (typeof data === 'string') {
                    $('#modal-Register').html(data);
                } else {
                    GetMessage(data);
                    if (data.Type !== 2) {
                        ResetViewFacility();
                    }
                }
            }
            HideSpinner();
        }, 100);
    });

    $(document).on('dblclick doubletap', '.img-slider', function (e) {
        let Url = $(this).find('img').attr('src');
        let Modal = $('#img-Modal');
        $('#img-Modal').find('#img01').attr('src', Url);
        $('#img-Modal').css('display', 'block');
        $('body').css('overflow', 'hidden');
    });

    $(document).on('click', '.btn-removeImg', function (e) {
        e.preventDefault();
        e.stopPropagation();
        let context = $(this);
        let Url = $(this).closest('.imageWrapper').find('img').attr('src');
        alertify.confirm('Excluir Foto', 'Tem certeza que deseja excluir essa imagem?', function (e) {
            ShowSpinner();
            let Result = GetJson('/Base/DeleteImageAsync', Url);
            if (Result !== null && Result.hasOwnProperty('Type')) {
                if (Result.Type === 1) {
                    GetMessage(Result);
                    $($(context).closest('li')).addClass('hide');
                }
            }
            HideSpinner();
        }, function (e) {

        });
    });
});

function Initialize() {

    $('.menu-Facility').css('background-color', 'rgba(27, 94, 32, 0.41)');

    let IdFacility = $('#IdFacility').val();
    if (IdFacility !== undefined && IdFacility !== '') {
        $('.FacilitiesInfo').removeClass('hide');
        if ($("#FacilityEdit").hasClass('collapse'))
            $('#FacilityBtn').trigger('click');
        setTimeout(function () {
            $("#FacilityEdit").get(0).scrollIntoView();
            HideSpinner();
        }, 100);
    }

    LoadMasks();
}

function FillFacilityData(Data) {
    $('#IdFacility').val(Data.IdFacility);
    $('#Status').val(Data.Status);
    $('#IdAddress').val(Data.IdAddress);
    $('#FacName').val(Data.Name);
    $('#FacPhone').val(Data.Phone).trigger('keyup');
    $('#FacEmail').val(Data.Email);
    $('#FacDescript').val(Data.Descript);
    $('#FacOwner').val(Data.IdOwner);
    $('#UpCep').val(Data.Cep).trigger('keyup');
    $('#UpStreet').val(Data.Street);
    $('#FacNumber').val(Data.Number);
    $('#FacDetail').val(Data.Detail);
    $('#UpNeighborhood').val(Data.Neighborhood);
    $('#UpState').val(Data.State).trigger('change');
    setTimeout(function () {
        $('#UpCity').val(Data.City);
    }, 1000);
    $('.FacilitiesInfo').removeClass('hide');
    if ($("#FacilityEdit").hasClass('collapse'))
        $('#FacilityBtn').trigger('click');

    $('#FacilityTab').find('#btn-minimize').trigger('click');

    setTimeout(function () {
        $("#FacilityEdit").get(0).scrollIntoView();
        HideSpinner();
    }, 100);

    if (Data.Urls != null && Data.Urls.length > 0) {
        let content = '<ul class="pgwSlideshow">';
        for (var i = 0; i < Data.Urls.length; i++) {
            content += '<li><div class="imageWrapper"><a href="#" class="img-slider"><img src="' + Data.Urls[i] + '"></a>' +
                '<span class="btn-removeImg"><i class="fa fa-trash fa-1-5x" aria-hidden="true"></i></span></div ></li>';
        }
        content += '</ul>';

        $('.container-slider').append(content);
        $('.pgwSlideshow').pgwSlideshow();
        $('.ps-current').addClass('hide');

    }
}

function InitializeDataTable() {

    var columnkeys = [];
    var newTable = '<thead><tr><th>IdFacility</th><th>Nome</th><th>Proprietário</th><th>Endereço</th><th>Situação</th><th></th></tr></thead>';

    $.ajax({
        url: '/RestrictedArea/Facility/ListFacilities',
        method: 'GET',
        dataType: 'json',
        success: function (content) {
            if (content && content.hasOwnProperty('Type') && content.Tipo === 2) {
                alertify.error(content.Message);
            }
            else {
                if (!$.fn.dataTable.isDataTable('#table-Facilities')) {
                    if (content.length > 0) {
                        var a = 0;
                        $.each(content[0], function (key, value) {
                            columnkeys[a] = { data: key };
                            a++;
                        });
                    } else {
                        for (var i = 0; i < 5; i++)
                            columnkeys[i] = { data: i };
                    }
                    $('#table-Facilities').append(newTable);
                    $('#table-Facilities').DataTable({
                        responsive: true,
                        //select: true,
                        data: content,
                        "columns": columnkeys,
                        "columnDefs": [{ "className": "dt-center", "targets": "_all" },
                        {
                            "targets": 0,
                            "searchable": false,
                            'orderable': false,
                            "visible": false
                        },
                        {
                            "targets": 5,
                            "searchable": false,
                            'orderable': false,
                            'width': '15%',
                            'render': function (data, type, full, meta) {
                                if (data)
                                    return '<button id="btnInfoFacility" class="btn-circle btn-dataTable" data-balloon="Informações" data-balloon-pos="up"> <i class="fa fa-info-circle fa-2x" aria-hidden="true"></i></button>' +
                                        '<button id= "btnEditFacility" class="btn-circle btn-dataTable" data-balloon="Editar" data-balloon-pos="up"> <i class="fa fa-pencil fa-2x" aria-hidden="true"></i></button >' +
                                        '<button id= "btnRemoveFacility" class="btn-circle btn-dataTable" data-balloon="Desativar" data-balloon-pos="up"> <i class="fa fa-times-circle fa-2x" aria-hidden="true"></i></button >';
                                else
                                    return '<button id="btnInfoFacility" class="btn-circle btn-dataTable" data-balloon="Informações" data-balloon-pos="up"> <i class="fa fa-info-circle fa-2x" aria-hidden="true"></i></button>' +
                                        '<button id= "btnActiveFacility" class="btn-circle btn-dataTable" data-balloon="Ativar" data-balloon-pos="up"> <i class="fa fa-check-circle fa-2x" aria-hidden="true"></i></button >';
                            }
                        }
                        ]
                    });
                }
                else
                    $('#table-Facilities').DataTable().clear().rows.add(content).columns.adjust().draw();
            }
            HideSpinner();
        }
    });
}

function ResetViewFacility() {
    $('.FacilitiesInfo').addClass('hide');
    InitializeDataTable();
    if (!$('#Facilities').hasClass('in'))
        $('#FacilitiesBtn').trigger('click');
}