﻿$(document).ready(function (e) {

    ShowSpinner();

    Initializefields();

    setTimeout(function () {
        InitializeDataTable();
    }, 100);

    $('#table-Enrollments').on('click', '#btnInfoTournament', function (e) {
        ShowSpinner();

        let data = GetDataFromTable('#table-Enrollments', $(this));

        window.open('/RestrictedArea/Tournament/Index/' + data.IdTournament, '_blank');

        setTimeout(function () {
            HideSpinner();
        }, 100);
    });

});

function Initializefields() {
    $('.menu-Home').css('background-color', 'rgba(27, 94, 32, 0.41)');
}

function InitializeDataTable() {

    var columnkeys = [];
    var newTable = '<thead><tr><th>IdTournament</th><th>Nome Jogador</th><th>Torneio</th><th>Categoria</th><th>Data Inscrição</th><th>Local</th><th></th></tr></thead>';

    $.ajax({
        url: '/RestrictedArea/Home/GetLastEnrollments',
        method: 'GET',
        dataType: 'json',
        success: function (content) {
            if (content && content.hasOwnProperty('Type') && content.Tipo === 2) {
                alertify.error(content.Message);
            }
            else {
                if (content.length > 0) {
                    var a = 0;
                    $.each(content[0], function (key, value) {
                        columnkeys[a] = { data: key };
                        a++;
                    });
                } else {
                    for (var i = 0; i < 7; i++)
                        columnkeys[i] = { data: i };
                }
                $('#table-Enrollments').append(newTable);
                $('#table-Enrollments').DataTable({
                    responsive: true,
                    //select: true,
                    "order": [[3, "desc"]],
                    data: content,
                    "columns": columnkeys,
                    "columnDefs": [{ "className": "dt-center", "targets": "_all" },
                        {
                            type: 'date-euro', "targets": [4]
                        },
                        {
                            "targets": 0,
                            "searchable": false,
                            'orderable': false,
                            'visible': false,
                        },
                    {
                        "targets": 6,
                        "searchable": false,
                        'orderable': false,
                        'render': function (data, type, full, meta) {
                            return '<button id="btnInfoTournament" class="btn-circle" data-balloon="Informações do Torneio" data-balloon-pos="up"> <i class="fa fa-info-circle fa-2x" aria-hidden="true"></i></button>';
                        }
                    }
                    ]
                });
            }

            HideSpinner();
        }
    });
}