﻿$(document).ready(function () {
    ShowSpinner();

    Initialize();

    setTimeout(function () {
        InitializeDataTableMain();
    }, 100);

    $('#table-Tournaments').on('click', '#btnInfoTournament', function (e) {
        ShowSpinner();
        let data = GetDataFromTable('#table-Tournaments', $(this));
        let TournamentData = GetJson('/RestrictedArea/Tournament/GetTournamentInfo', data.IdTournament);
        FillTournament(TournamentData, false);
    });

    $('#table-Tournaments').on('click', '#btnEditTournament', function (e) {
        let data = GetDataFromTable('#table-Tournaments', $(this));
        let TournamentData = GetJson('/RestrictedArea/Tournament/GetTournamentInfo', data.IdTournament);
        FillTournament(TournamentData, true);
        ShowSpinner();
    });

    $('#table-Tournaments').on('click', '#btnRemoveTournament', function (e) {
        let data = GetDataFromTable('#table-Tournaments', $(this));
        alertify.confirm('Desativar Torneio', 'Tem certeza que deseja desativar esse torneio?', function (e) {
            location.href = '/RestrictedArea/Tournament/RemoveTournament?IdTournament=' + data.IdTournament;
        }, function (e) {

        });
    });

    $('#table-Tournaments').on('click', '#btnActiveTournament', function (e) {
        let data = GetDataFromTable('#table-Tournaments', $(this));
        alertify.confirm('Reativar Torneio', 'Tem certeza que deseja reativar esse torneio?', function (e) {
            location.href = '/RestrictedArea/Tournament/ReactiveTournament?IdTournament=' + data.IdTournament;
        }, function (e) {

        });
    });

    $('#btnNewTournament').on('click', function (e) {
        e.preventDefault();
        ShowSpinner();
        //BuildUmpireDataTable('Cad');
        setTimeout(function () {
            OpenModal('/RestrictedArea/Tournament/Create', 'modal-lg');
            BuildUmpireDataTable('Cad');
            HideSpinner();
        }, 100);
    });

    $('#btn-closeCat').on('click', function () {
        let UmpireInfo = $('.UmpireInfo').hasClass('hide');
        if (UmpireInfo)
            $('.tournamentInfo').removeClass('col-md-6').removeClass('col-lg-6').addClass('col-md-12').addClass('col-lg-12');
        $.fn.dataTable.tables({ visible: true, api: true }).columns.adjust();
    });

    $('#btn-closeUmp').on('click', function () {
        let CatInfo = $('.CatInfo').hasClass('hide');
        if (CatInfo)
            $('.tournamentInfo').removeClass('col-md-6').removeClass('col-lg-6').addClass('col-md-12').addClass('col-lg-12');
        $.fn.dataTable.tables({ visible: true, api: true }).columns.adjust();
    });

    $('table').on('click', '.checkAll', function (e) {
        CheckAllCheckBoxes(e, this.checked);
    });

    $('#btnAddUmpireUp').on('click', function (e) {
        e.preventDefault();
        ShowSpinner();
        let table = $('#table-UmpiresInfo').DataTable();
        let Email = $('#UserEmailUp').val();
        let IdTournament = $('#UpIdTournament').val();
        if (IdTournament === '')
            IdTournament = 0;
        let Data = table.rows().data();
        if (Email !== '') {
            if ($.grep(Data, function (n) { return n.Email === Email; }).length > 0)
                alertify.warning("Usuário já foi selecionado!");
            else {
                let UserData = GetJson('/RestrictedArea/Tournament/GetUserInfo', Email);

                if (UserData !== null && UserData !== undefined && !UserData.hasOwnProperty('Type')) {
                    let Umpire = FillUmpireObject(UserData, IdTournament);
                    table.row.add(Umpire).columns.adjust().draw();
                }
                else
                    alertify.warning('Nenhum usuário encontrado!\nInforme um e-mail válido!');
            }
        }
        else
            alertify.warning('Informe o email do usuário!');
        HideSpinner();
    });

    $('#table-UmpiresInfo').on('click', '#btnRemoveUmpire', function (e) {
        RemoveRow(e, $(this));
    });

    $('#table-EnrolledPlayers').on('click', '#btnRemovePerson', function (e) {
        e.preventDefault();
        let table = $('#table-EnrolledPlayers').DataTable();
        let Data = GetDataFromTable('#table-EnrolledPlayers', $(this));
        let Param = Data.IdPerson + ',' + $('#UpIdTournament').val();
        let Result = GetJson('/RestrictedArea/Tournament/RemovePlayer', Param);
        if (Result !== null && Result !== undefined) {
            GetMessage(Result);
            RemoveRow(e, $(this));
        }
    });

    $('#formUpdateTournament').on('submit', function (e) {
        e.preventDefault();

        let Find = false;
        let Categories = [];
        let Umpires = [];
        let Players = [];

        let AllCategory = $('#table-CategoriesInfo').DataTable().rows().data();
        let AllUmpires = $('#table-UmpiresInfo').DataTable().rows().data();
        let AllPlayers = $('#table-EnrolledPlayers').DataTable().rows().data();

        for (var i = 0; i < AllCategory.length; i++) {
            if (AllCategory[i].Active)
                Categories.push(AllCategory[i]);
        }

        for (var b = 0; b < AllPlayers.length; b++) {
            if ($.grep(Categories, function (e) { return e.IdCategory === AllPlayers[b].IdCategory; }).length === 0)
                Find = true;
            Players.push(AllPlayers[b]);
        }

        for (var a = 0; a < AllUmpires.length; a++)
            Umpires.push(AllUmpires[a]);
        let fdata = new FormData($(this)[0]);
        fdata.append("Categories", JSON.stringify(Categories));
        fdata.append("Umpires", JSON.stringify(Umpires));
        fdata.append("Players", JSON.stringify(Players));

        if (Find) {
            alertify.confirm('Atenção', 'Há jogadores inscritos em categorias que foram removidas, deseja continuar e remover esses jogadores do torneio?', function () {
                ShowSpinner();
                setTimeout(function () {
                    let data = SubmitFormwithDataTable('/RestrictedArea/Tournament/SaveTournamentAsync', fdata, e);
                    if (typeof data === 'string') {
                        $('#modal-Register').html(data);
                        FillTournamentsDataOnFailure();
                    } else {
                        GetMessage(data);
                        if (data.Type !== 2)
                            ResetView();
                    }
                }, 100);
            }, function (e) {

            });
        } else {
            ShowSpinner();
            setTimeout(function () {
                let data = SubmitFormwithDataTable('/RestrictedArea/Tournament/SaveTournamentAsync', fdata, e);
                if (typeof data === 'string') {
                    $('#modal-Register').html(data);
                    FillTournamentsDataOnFailure();
                } else {
                    GetMessage(data);
                    if (data.Type !== 2)
                        ResetView();
                }
            }, 100);
        }

    });

    $('#table-Tournaments').on('click', '#btnGenerateKey', function (e) {
        e.preventDefault();
        ShowSpinner();
        let table = $('#table-Tournaments').DataTable();
        let Data = table.row($(this).parents('tr')).data();
        if (Data === undefined)
            Data = table.row($(this).parent().prev()).data();
        if (Data !== undefined && Data !== null) {
            let IdTournament = Data.IdTournament;
            alertify.confirm('Gerar chave de Torneio', 'Tem certeza que deseja gerar chave para esse torneio?', function (e) {
                location.href = '/RestrictedArea/Tournament/GenerateDraw?IdTournament=' + IdTournament;
            }, function (e) {

            });
        }
    });

    $('#table-CategoriesInfo').on('click', '#btnGenerateKey', function (e) {
        e.preventDefault();
        ShowSpinner();
        let table = $('#table-Tournaments').DataTable();
        let Data = table.row($(this).parents('tr')).data();
        if (Data === undefined)
            Data = table.row($(this).parent().prev()).data();
        if (Data !== undefined && Data !== null) {
            let IdTournament = Data.IdTournament;
            alertify.confirm('Gerar chave de Torneio', 'Tem certeza que deseja gerar chave para esse torneio?', function (e) {
                location.href = '/RestrictedArea/Tournament/GenerateDraw?IdTournament=' + IdTournament;
            }, function (e) {

            });
        }
    });

    $('#table-CategoriesInfo').on('click', '#btnShowKey', function (e) {
        e.preventDefault();
        let table = $('#table-CategoriesInfo').DataTable();
        let Data = table.row($(this).parents('tr')).data();
        let IdTournament = $('#UpIdTournament').val();
        if (Data === undefined)
            Data = table.row($(this).parent().prev()).data();
        if (Data !== undefined && IdTournament !== '')
            window.open('/RestrictedArea/Tournament/ShowDraw?IdTournament=' + IdTournament + '&IdCategory=' + Data.IdCategory, '_blank');
        
        else
            alertify.warning('Nada encontrado!');
    });

    $('#table-CategoriesInfo').on('click', '#btnManageCalendar',function (e) {
        let table = $('#table-CategoriesInfo').DataTable();
        let Data = table.row($(this).parents('tr')).data();
        let IdTournament = $('#UpIdTournament').val();
        if (Data === undefined)
            Data = table.row($(this).parent().prev()).data();
        let Param = IdTournament + ',' + Data.IdCategory;
        if (Data !== undefined && IdTournament !== '') {
            let CData = GetJson('/RestrictedArea/Tournament/GetMatchesFromTournament', Param);
            $('#table-Calendar').DataTable().clear().rows.add(CData).columns.adjust().draw();
            $('.Calendar').removeClass('hide');
            $("#CalendarManage").get(0).scrollIntoView();
        }

    });

    $('#btn-SaveCalendar').on('click', function (e) {
        e.preventDefault();
        let TData = $('#table-Calendar').DataTable().data();
        let Data = [];
        for (var i = 0; i < TData.length; i++) {
            Data.push(TData[i]);
        }
        let fdata = new FormData();
        fdata.append('oMatches', JSON.stringify(Data));
        SubmitForm('/RestrictedArea/Tournament/SetMachesTime', fdata, e);
        $('.Calendar').addClass('hide');

        $('#calendar-Events').empty();
        $('#calendar-Events').removeClass('eventCalendar-wrap');
        $('#calendar-Events').removeAttr('data-current-month');
        $('#calendar-Events').removeAttr('data-current-year');
        LoadEvents();


    });

    $('table').on('focusout', '.Date-Field', function (e) {
        e.preventDefault();
        let table = $('#' + e.delegateTarget.id).DataTable();
        let cell = $(this).closest('td');
        let row = table.row($(this).closest('tr')).index();
        if (this.value !== null && this.value !== undefined && this.value !== '') {
            if (this.type === 'date') {
                let EndDate = $('#UpEndDate').val();
                let DeadLine = $('#UpEnrollmentDeadline').val();
                let Valid = false;
                if (moment(this.value).isBefore(moment(EndDate).format('YYYY-MM-DD')) || this.value === EndDate)
                    Valid = true;
                if (!moment(this.value).isBefore(moment(DeadLine).format('YYYY-MM-DD')) && this.value !== DeadLine)
                    Valid = true;
                else
                    Valid = false;
                if (Valid) {
                    table.cell(cell).data(moment(this.value).format('DD/MM/YYYY')).draw(false);
                    table.cell(row, 6).data(true).draw(false);
                }
                else {
                    alertify.warning('Data Inválida!');
                    table.cell(cell).data('').draw(false);
                }
            }
            else if (this.type === 'time') {
                table.cell(cell).data(this.value).draw(false);
                table.cell(row, 6).data(true).draw(false);
            }
        }
    });

    $('.img-Tournament').on('dblclick doubletap ', function (e) {
        let Url = $(this).find('img').attr('src');
        let Modal = $('#img-Modal');
        $('#img-Modal').find('#img01').attr('src', Url);
        $('#img-Modal').css('display', 'block');
        $('body').css('overflow', 'hidden');
    })
});

function Initialize() {
    $('.menu-Tournament').css('background-color', 'rgba(27, 94, 32, 0.41)');
    let IdParam = $('#IdTournamentParam').val();
    if (IdParam !== undefined && IdParam !== null) {
        if (IdParam !== '0') {
            let TournamentData = GetJson('/RestrictedArea/Tournament/GetTournamentInfo', IdParam);
            if (TournamentData !== undefined && TournamentData !== null) {
                FillTournament(TournamentData, false);
            }
            else
                alertify.warning('Nada Encontrado!');
        }
    }

    LoadMasks();

    BuildCalendarDataTableTable();
}

function FillUmpireObject(UserData, IdTournament) {
    let Object = {
        'IdPerson': UserData.IdPerson, 'IdTournament': IdTournament,
        'Name': UserData.Name + UserData.LastName, 'Email': UserData.Email
    };
    return Object;
}

function FillTournament(Data, isEdit) {
    $('.tournamentInfo').removeClass('col-md-6').removeClass('col-lg-6').addClass('col-md-6').addClass('col-lg-6');
    $('#TournamentBtn').text('Informações do Torneio');
    $('#UpNameTournament').val(Data.NameTournament);
    $('#UpDescription').val(Data.Description);
    $('#UpStarDate').val(moment(FormatDate(Data.StartDate)).format('YYYY-MM-DD'));
    $('#UpEndDate').val(moment(FormatDate(Data.EndDate)).format('YYYY-MM-DD'));
    $('#UpEnrollmentDeadline').val(moment(FormatDate(Data.EnrollmentDeadline)).format('YYYY-MM-DD'));
    $('#UpEnrollmentPrice').rules('remove', 'number');
    $('#UpEnrollmentPrice').val(AlterDot(Data.EnrollmentPrice.toString())).trigger('keyup');
    $('#UpIdOwner').val(Data.IdOwner);

    if (Data.Picture != null) {
        $('#UpPictureTournament').attr('src', Data.Picture);
        $('.img-Tournament').removeClass('hide');
    }
    else
        $('.img-Tournament').addClass('hide');

    $('#UpIdFacility').val(Data.IdFaciity);
    $('#UpIdTournament').val(Data.IdTournament);
    $('.UmpireInfo').removeClass('hide');
    //if (Data.Picture !== '') {
    //    $('.img-Tournament').find('img').attr('src', Data.Picture);
    //    $('.img-Tournament').removeClass('hide');
    //}
    $('.categories-hidden').addClass('hide');

    $('#formUpdateTournament :input:not(.btn-window)').attr('disabled', true);

    $('.TounamentsInfo').removeClass('hide');
    if ($("#TournamentEdit").hasClass('collapse'))
        $('#TournamentBtn').trigger('click');

    $('#TournamentTab').find('#btn-minimize').trigger('click');

    //setTimeout(function () {
    //    let table = $('#table-EnrolledPlayers').DataTable();
    //    table.clear().rows.add(Data.TournamentPlayers).columns.adjust().draw();
    //    $("#TournamentEdit").get(0).scrollIntoView();
    //}, 100);
    let View = '';
    if (isEdit) {
        EditTournament(Data.IdTournament);
        InitializeDataTableEnrolledPlayers(Data.TournamentPlayers, 'Edit');
        SetCategories(Data.IdTournament, 'Edit');
        View = 'Edit';
    }
    else {
        InitializeDataTableEnrolledPlayers(Data.TournamentPlayers, 'Info');
        SetCategories(Data.IdTournament, 'Info');
        $('.AddU').addClass('hide');
        View = 'Info';
    }

    SetUmpires(Data.IdTournament, View);
    //let table = $('#table-EnrolledPlayers').DataTable();
    //table.clear().rows.add(Data.TournamentPlayers).columns.adjust().draw();

    $.fn.dataTable.tables({ visible: true, api: true }).columns.adjust();
    HideSpinner();

    $("#TournamentEdit").get(0).scrollIntoView();
}

function EditTournament(IdTournament) {
    $('#TournamentBtn').text('Editar Torneio');
    $('.tournamentInfo').removeClass('col-md-12').removeClass('col-lg-12').addClass('col-md-6').addClass('col-lg-6');
    $('.picture-hiden').removeClass('hide');
    $('.UmpireInfo').removeClass('hide');
    $('.AddU').removeClass('hide');
    $('#formUpdateTournament :input').attr('disabled', false);
    setTimeout(function () {
        HideSpinner();
    }, 100);

}

function SetCategories(IdTournament, View) {
    $('.categories-hidden').removeClass('hide');
    $('.CatInfo').removeClass('hide');
    BuildCatDataTable('Info', View);
    let table = $('#table-CategoriesInfo').DataTable();

    let CategoriesFinal = null;
    let CategoriesTour = null;

    if (View === 'Info') {
        $('#CategoriesEdit').find('.modal-title').text('');
        CategoriesTour = GetJson('/RestrictedArea/Tournament/ListCategoriesTournament', IdTournament);
        CategoriesFinal = CategoriesTour;
    }
    else {
        $('#CategoriesEdit').find('.modal-title').text('Selecione as Categorias');
        let Categories = GetJsonWithOutParam('/RestrictedArea/Tournament/ListCategories');
        CategoriesTour = GetJson('/RestrictedArea/Tournament/ListCategoriesTournament', IdTournament);
        CategoriesFinal = MergeCategories(Categories, CategoriesTour);
    }
    table.clear().rows.add(CategoriesFinal).columns.adjust().draw();
    let Status = $.grep(CategoriesFinal, function (e) { return e.Active === false; }).length === 1;

    if (!Status)
        $('.checkAll').prop('checked', true);
}

function SetUmpires(IdTournament, View) {

    BuildUmpireDataTable('Info', View);

    if (View === 'Info')
        $('#UmpireEdit').find('.modal-title').text('');
    else
        $('#UmpireEdit').find('.modal-title').text('Selecione os Árbitros');

    let tableUmp = $('#table-UmpiresInfo').DataTable();
    let Umpires = GetJson('/RestrictedArea/Tournament/GetUmpires', IdTournament);

    tableUmp.clear().rows.add(Umpires).columns.adjust().draw();
}

function MergeCategories(Categories, CategoriesSec) {
    for (var i = 0; i < Categories.length; i++) {
        for (var a = 0; a < CategoriesSec.length; a++) {
            if (Categories[i].IdCategory === CategoriesSec[a].IdCategory)
                Categories[i] = CategoriesSec[a];
        }
    }
    return Categories;
}

function InitializeDataTableMain() {
    var columnkeys = [];
    var newTable = '<thead><tr><th>IdTournament</th><th>Nome</th><th>Data Início</th><th>Data Limite Inscrição</th><th>Total de Inscritos</th><th></th><th></th><th></th><th></th><th></th></tr></thead>';

    let btnInfo = '<button id="btnInfoTournament" class="btn-circle btn-dataTable" data-balloon="Informações" data-balloon-pos="up"> <i class="fa fa-info-circle fa-2x" aria-hidden="true"></i></button>';
    let btnEdit = '<button id= "btnEditTournament" class="btn-circle btn-dataTable" data-balloon="Editar" data-balloon-pos="up"> <i class="fa fa-pencil fa-2x" aria-hidden="true"></i></button >';
    let btnDel = '<button id= "btnRemoveTournament" class="btn-circle btn-dataTable" data-balloon="Desativar" data-balloon-pos="up"> <i class="fa fa-times-circle fa-2x" aria-hidden="true"></i></button >';
    let btnActive = '<button id= "btnActiveTournament" class="btn-circle btn-dataTable" data-balloon="Ativar" data-balloon-pos="up"> <i class="fa fa-check-circle fa-2x" aria-hidden="true"></i></button >';
    let btnGenKey = '<button id= "btnGenerateKey" class="btn-circle btn-dataTable" data-balloon="Gerar Chave" data-balloon-pos="up"> <i class="fa fa-sitemap fa-2x" aria-hidden="true"></i></button >';

    $.ajax({
        url: '/RestrictedArea/Tournament/ListTournaments',
        method: 'GET',
        dataType: 'json',
        success: function (content) {
            if (content && content.hasOwnProperty('Type') && content.Tipo === 2) {
                alertify.error(content.Message);
            }
            else {

                if (!$.fn.dataTable.isDataTable('#table-Tournaments')) {
                    if (content.length > 0) {
                        var a = 0;
                        $.each(content[0], function (key, value) {
                            columnkeys[a] = { data: key };
                            a++;
                        });
                    } else {
                        for (var i = 0; i < 10; i++)
                            columnkeys[i] = { data: i };
                    }
                    $('#table-Tournaments').append(newTable);
                    $('#table-Tournaments').DataTable({
                        responsive: true,
                        //select: true,
                        data: content,
                        "columns": columnkeys,
                        "columnDefs": [{ "className": "dt-center", "targets": "_all" },
                            {
                                type: 'date-euro', "targets": [2, 3]
                            },
                        {
                            "targets": [0, 6, 7, 8, 9],
                            "searchable": false,
                            'orderable': false,
                            "visible": false
                        },
                        {
                            "targets": 5,
                            "searchable": false,
                            'orderable': false,
                            'width': '20%',
                            'render': function (data, type, full, meta) {
                                if (data && !full.HasPast) {
                                    if (full.HasDraw)
                                        return btnInfo;
                                    else if (full.CanDraw)
                                        return btnInfo + btnEdit + btnDel + btnGenKey;
                                    else if (!full.CanDraw && full.EndEnrollment)
                                        return btnInfo + btnDel;
                                    else
                                        return btnInfo + btnEdit + btnDel;

                                }
                                else if (data && full.HasPast)
                                    return btnInfo;
                                else if (!data && !full.HasPast)
                                    return btnInfo + btnActive;
                                else
                                    return btnInfo;
                            }
                        }
                        ]
                    });
                }
                else
                    $('#table-Tournaments').DataTable().clear().rows.add(content).columns.adjust().draw();
            }
            HideSpinner();
        }
    });
}

function InitializeDataTableEnrolledPlayers(Data, View) {

    var newTable = '<thead><tr><th>Código</th><th>Nome</th><th>Data Inscrição</th><th>Categoria</th><th>IdCategoria</th><th></th></tr></thead>';
    let Show = View === 'Info' ? false : true;

    $('#table-EnrolledPlayers').empty();
    $('#table-EnrolledPlayers').append(newTable);
    $('#table-EnrolledPlayers').DataTable({
        responsive: true,
        "columns": [{ data: 'IdPerson' }, { data: 'FullName' }, { data: 'EnrollmentDate' }, { data: 'Category' }, { data: 'IdCategory' }],
        "columnDefs": [{ "className": "dt-center", "targets": "_all" },
        {
            "targets": [0, 4],
            "searchable": false,
            'orderable': false,
            "visible": false
        },
        {
            "targets": 5,
            "searchable": Show,
            'orderable': Show,
            "visible": Show
        },
        {
            "targets": 5,
            "searchable": false,
            'width': '10%',
            'orderable': false,
            'render': function (data, type, full, meta) {
                return '<button type="button" id="btnRemovePerson" class="btn-circle" data-balloon="Remover Jogador" data-balloon-pos="up"> <i class="fa fa-times-circle fa-2x" aria-hidden="true"></i></button >';
            }
        }
        ],
        data: Data
    });
}

function BuildCatDataTable(id, View) {
    $('#table-Categories' + id).empty();

    let show = false;
    let Type = 0;
    let newTable = '';
    if (id !== 'Cad' && View !== 'Edit')
        show = true;

    if (View === 'Info') {
        Type = 1;
        newTable = '<thead><tr><th>IdCategory</th><th>Descrição</th><th>Prêmio</th><th><input type="checkbox" disabled class="checkAll" /></th><th></th></tr></thead>';
    }
    else
        newTable = '<thead><tr><th>IdCategory</th><th>Descrição</th><th>Prêmio</th><th><input type="checkbox" class="checkAll" /></th><th></th></tr></thead>';

    let btnKey = '<button type="button" id="btnShowKey" class="btn-circle" data-balloon="Visualizar Chave" data-balloon-pos="up"> <i class="fa fa-info-circle fa-2x" aria-hidden="true"></i></button>';

    let btnEvent = '<button type="button" id="btnManageCalendar" class="btn-circle" data-balloon="Gerenciar Horários" data-balloon-pos="up"> <i class="fa fa-clock-o  fa-2x" aria-hidden="true"></i></button>';

    $('#table-Categories' + id).append(newTable);
    $('#table-Categories' + id).DataTable({
        responsive: true,
        "sPaginationType": "full_numbers",
        "columns": [
            { data: 'IdCategory' },
            { data: 'Description' },
            { data: 'Prize' },
            { data: 'Active' },
            { data: 'Key' }
        ],
        "columnDefs": [{ "className": "dt-center", "targets": "_all" },
        {
            "targets": 0,
            "searchable": false,
            'orderable': false,
            "visible": false
            },
        {
            "targets": 1,
            'width': '45%'
        },
        {
            "targets": 2,
            "searchable": false,
            'orderable': false,
            'width': '25%',
            'className': 'money decimal',
            'render': function (data, type, full, meta) {
                if (Type !== 1 && data === 0)
                    return '<input type="text" class="form-control modal-Field decimal money" name="Prize" id="PrizeModal" value=" " />';
                else if (Type !== 1 && data !== 0)
                    return '<input type="text" class="form-control modal-Field decimal money" name="Prize" id="PrizeModal" value="' + AlterDot(FloorFigure(parseFloat(data))) + '" />';
                else 
                    return AlterDot(FloorFigure(parseFloat(data)));
            }
        },
        {
            "targets": 3,
            "searchable": false,
            'orderable': false,
            'width': '10%',
            "visible": !show,
            'render': function (data, type, full, meta) {
                if (data && Type !== 1)
                    return '<input type="checkbox" class="modal-Field" checked value="true" />';
                else if (!data && Type !== 1)
                    return '<input type="checkbox" class="modal-Field" value="false" />';
                else if (data && Type === 1)
                    return '<input type="checkbox" class="modal-Field" checked value="true" disabled />';
                else if (!data && Type === 1)
                    return '<input type="checkbox" class="modal-Field" value="false" disabled />';
            }
        },
        {
            "targets": 4,
            "searchable": show,
            'orderable': show,
            "visible": show,
            'width': '15%',
            'render': function (data, type, full, meta) {
                if (data !== 0)
                    return btnKey + btnEvent;
                else
                    return '';
            }
        }
        ],
        "fnDrawCallback": function () {
            LoadMasks();
        }

    });
}

function BuildUmpireDataTable(id, View) {

    let Show = true;

    if (View !== undefined && View === 'Info')
        Show = false;
    $('#table-Umpires' + id).empty();
    var newTable = '<thead><tr><th>IdPerson</th><th>IdTournament</th><th>Nome</th><th>Email</th><th></th></tr></thead>';
    $('#table-Umpires' + id).append(newTable);
    $('#table-Umpires' + id).DataTable({
        responsive: true,
        "columns": [
            { data: 'IdPerson' },
            { data: 'IdTournament' },
            { data: 'Name' },
            { data: 'Email' }
        ],
        "columnDefs": [{ "className": "dt-center", "targets": "_all" },
        {
            "targets": [0, 1],
            "searchable": false,
            'orderable': false,
            "visible": false
        },
        {
            "targets": 4,
            "searchable": Show,
            'orderable': Show,
            "visible": Show,
            'width': '30px',
            'render': function (data, type, full, meta) {
                return '<button type="button" id= "btnRemoveUmpire" class="btn-circle" data-balloon="Remover" data-balloon-pos="up"> <i class="fa fa-times-circle fa-2x" aria-hidden="true"></i></button >';
            }
        }
        ]
    });
}

function BuildCalendarDataTableTable() {

    let newTable = '<thead><tr><th>IdMatch</th><th>Rodada</th><th>Jogador 1</th><th>Jogador 2</th><th>Data</th><th>Hora</th></tr></thead>';

    $('#table-Calendar').append(newTable);
    $('#table-Calendar').DataTable({
        responsive: true,
        "columns": [
            { data: 'IdMatch' },
            { data: 'Round' },
            { data: 'Player1' },
            { data: 'Player2' },
            { data: 'Date' },
            { data: 'Time' },
            { data: 'IsUpdate'}
        ],
        "columnDefs": [{ "className": "dt-center", "targets": "_all" },
        {
            "targets": [0,6],
            "searchable": false,
            'width': '7.5%',
            'orderable': false,
            "visible": false
        },
        {
            "targets": 1,
            'width': '25%'
        },
        {
            "targets": [2, 3],
            'width': '25%'
        },
        {
            "targets": 4,
            'width': '20%',
            'render': function (data, type, full, meta) {
                if (data !== null && data !== '')
                    return '<input type="date" class="form-control Date-Field" value="' + moment(data, 'DD/MM/YYYY').format('YYYY-MM-DD') + '" />';
                else
                    return '<input type="date" class="form-control Date-Field" />';
            }
        },
        {
            "targets": 5,
            'width': '15%',
            'render': function (data, type, full, meta) {
                if (data !== null && data !== '')
                    return '<input type="time" class="form-control Date-Field" value="' + data + '" />';
                else
                    return '<input type="time" class="form-control Date-Field" />';
            }
        }
        ]
    });
}

function FillTournamentsDataOnFailure() {
    BuildCatDataTable('Cad');
    BuildUmpireDataTable('Cad');

    let Categories = GetJsonWithOutParam('/RestrictedArea/Tournament/ListCategories');

    let Umpires = $('#UmpiresJsonCad').val();
    let CategoriesSelected = $('#CategoriesJsonCad').val();
    if (Umpires !== undefined && Umpires !== '')
        $('#table-UmpiresCad').DataTable().clear().rows.add($.parseJSON(Umpires)).columns.adjust().draw();
    if (CategoriesSelected !== undefined && CategoriesSelected !== '') {
        let CategoriesFinal = MergeCategories(Categories, $.parseJSON(CategoriesSelected));
        $('#table-CategoriesCad').DataTable().clear().rows.add(CategoriesFinal).columns.adjust().draw();
    }
}

function GetCatergories() {

    $.ajax({
        url: '/RestrictedArea/Tournament/ListCategories',
        method: 'GET',
        dataType: 'json',
        success: function (content) {
            if (content && content.hasOwnProperty('Type') && content.Tipo === 2)
                alertify.error(content.Message);
            else
                $('#table-CategoriesCad').DataTable().clear().rows.add(content).columns.adjust().draw();
            HideSpinner();
        }
    });
}

function ResetView() {
    $('.TounamentsInfo').addClass('hide');
    InitializeDataTableMain();
    $('#TournamentsBtn').trigger('click');
}

function SetBrackets(Bracket) {

    let Object = JSON.parse(Bracket);
    let Titles = Object.Names;
    let Rounds = [];
    for (var i = 0; i < Object.Rounds.length; i++) {
        Rounds.push(Object.Rounds[i].Players);
    }

    setTimeout(function () {
        $(".brackets").brackets({
            titles: Titles,
            rounds: Rounds,
            color_title: 'black',
            border_color: 'black',
            color_player: 'black',
            bg_player: 'white',
            color_player_hover: '46CFB0',
            bg_player_hover: '#9ef19e',
            border_radius_player: '5px',
            border_radius_lines: '5px'
        });

        if (!isMobileDevice())
            $('.container-draw').removeClass('hide');
    }, 100);
}