﻿$(document).ready(function (e) {

    ShowSpinner();

    Initializefields();

    setTimeout(function () {
        InitializeDataTable();
    }, 100);


    $('#table-Users').on('click', '#btnInfoUser', function (e) {
        ShowSpinner();
        let data = GetDataFromTable('#table-Users', $(this));
        OpenModalWithParam('/RestrictedArea/Home/GetUserInfo', 'modal-lg', data.IdUser);
        setTimeout(function () {
            HideSpinner();
        }, 100);
    });

    $('#table-Users').on('click', '#btnEditUser', function (e) {
        let data = GetDataFromTable('#table-Users', $(this));
        let UserData = GetJson('/RestrictedArea/User/GetUserInfo', data.IdUser);

        ShowSpinner();
        setTimeout(function () {
            FillUserData(UserData);
        }, 100);
    });

    $('#table-Users').on('click', '#btnRemoveUser', function (e) {
        let data = GetDataFromTable('#table-Users', $(this));
        alertify.confirm('Desativar Usuário', 'Tem certeza que deseja desativar esse usuário?', function (e) {
            location.href = '/RestrictedArea/User/RemoveUser?IdUser=' + data.IdUser;
        }, function (e) {

        });
    });

    $('#table-Users').on('click', '#btnActiveUser', function (e) {
        let data = GetDataFromTable('#table-Users', $(this));
        alertify.confirm('Desativar Usuário', 'Tem certeza que deseja reativar esse usuário?', function (e) {
            location.href = '/RestrictedArea/User/ReactiveUser?IdUser=' + data.IdUser;
        }, function (e) {

        });
    });

    $('#formUpdateUser').on('submit', function (e) {
        ShowSpinner();
    });


    if ($('#IdUser').val() !== "") {
        $('.userInfo').removeClass('hide');
        if ($("#UserEdit").hasClass('collapse'))
            $('#UserBtn').trigger('click');
        setTimeout(function () {
            HideSpinner();
            $("#UserEdit").get(0).scrollIntoView();
        }, 100);
    }

});

function Initializefields() {
    $('.menu-User').css('background-color', 'rgba(27, 94, 32, 0.41)');
}

function FillUserData(Data) {

    $('#IdUser').val(Data.IdUser);
    $('#Name').val(Data.Name);
    $('#LastName').val(Data.LastName);
    $('#Email').val(Data.Email);
    $('#Tel').val(Data.Tel).trigger('keyup');
    if (Data.Gender === 'M')
        $('#GenderM').prop('checked', true);
    else
        $('#GenderF').prop('checked', true);
    $('#IdHand').val(Data.IdHand);
    $('#IdClass').val(Data.IdClass);
    $('#Cep').val(Data.Cep).trigger('keyup');
    $('#Street').val(Data.Street);
    $('#Number').val(Data.Number);
    $('#Detail').val(Data.Detail);
    $('#Neighborhood').val(Data.Neighborhood);
    $('#State').val(Data.State);
    $('#BirthDateFormat').val(Data.BirthDateFormat);
    $('#ProfilePicture').val();
    $('#PremiumAccess').val(Data.PremiumAccess);
    $('#UserAccess').val(Data.UserAccess);
    $('#State').trigger('change');
    if (Data.UserAccess)
        $('#UserAccess').prop('checked', true);
    if (Data.PremiumAccess)
        $('#PremiumAccess').prop('checked', true);
    setTimeout(function () {
        $('#City').val(Data.City);
    }, 1000);
    $('.userInfo').removeClass('hide');
    if ($("#UserEdit").hasClass('collapse'))
        $('#UserBtn').trigger('click');
    $('#UserTab').find('#btn-minimize').trigger('click');

    setTimeout(function () {
        $("#UserEdit").get(0).scrollIntoView();
        HideSpinner();
    }, 100);
}

function InitializeDataTable() {
    var columnkeys = [];
    var newTable = '<thead><tr><th>IdUser</th><th>Usuário</th><th>E-mail</th><th>Data Cadastro</th><th>Tipo</th><th>Status</th><th></th></tr></thead>';
    $.ajax({
        url: '/RestrictedArea/User/ListUsers',
        method: 'GET',
        dataType: 'json',
        success: function (content) {
            if (content && content.hasOwnProperty('Type') && content.Tipo === 2) {
                alertify.error(content.Message);
                HideSpinner();
            }
            else {
                if (content.length > 0) {
                    var a = 0;
                    $.each(content[0], function (key, value) {
                        columnkeys[a] = { data: key };
                        a++;
                    });
                } else {
                    for (var i = 0; i < 7; i++)
                        columnkeys[i] = { data: i };
                }
                $('#table-Users').append(newTable);
                $('#table-Users').DataTable({
                    responsive: true,
                    //select: true,
                    data: content,
                    "columns": columnkeys,
                    "order": [[1, "asc"]],
                    "columnDefs": [{ "className": "dt-center", "targets": "_all" },
                        {
                            type: 'date-euro', "targets": [3]
                        },
                    {
                        "targets": 0,
                        "searchable": false,
                        'orderable': false,
                        "visible": false
                    },
                    {
                        "targets": 6,
                        "searchable": false,
                        'orderable': false,
                        'render': function (data, type, full, meta) {
                            if (data)
                                return '<button id="btnInfoUser" class="btn-circle btn-dataTable" data-balloon="Informações" data-balloon-pos="up"> <i class="fa fa-info-circle fa-2x" aria-hidden="true"></i></button>' +
                                    '<button id= "btnEditUser" class="btn-circle btn-dataTable" data-balloon="Editar" data-balloon-pos="up"> <i class="fa fa-pencil fa-2x" aria-hidden="true"></i></button >' +
                                    '<button id= "btnRemoveUser" class="btn-circle btn-dataTable" data-balloon="Desativar" data-balloon-pos="up"> <i class="fa fa-times-circle fa-2x" aria-hidden="true"></i></button >';
                            else
                                return '<button id="btnInfoUser" class="btn-circle btn-dataTable" data-balloon="Informações" data-balloon-pos="up"> <i class="fa fa-info-circle fa-2x" aria-hidden="true"></i></button>' +
                                    '<button id= "btnEditUser" class="btn-circle btn-dataTable" data-balloon="Editar" data-balloon-pos="up"> <i class="fa fa-pencil fa-2x" aria-hidden="true"></i></button >' +
                                    '<button id= "btnActiveUser" class="btn-circle btn-dataTable" data-balloon="Ativar" data-balloon-pos="up"> <i class="fa fa-check-circle fa-2x" aria-hidden="true"></i></button >';
                        }
                    }
                    ]
                });
            }
            HideSpinner();
        }
    });
}