﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using TpmDAO.Entity;
using TpmDAO.Persistence;

namespace TpmMVC.Controllers
{
    public class CustomRoleProvider : RoleProvider
    {
        public override string ApplicationName { get => throw new NotImplementedException(); set => throw new NotImplementedException(); }

        public override void AddUsersToRoles(string[] usernames, string[] roleNames)
        {
            throw new NotImplementedException();
        }

        public override void CreateRole(string roleName)
        {
            throw new NotImplementedException();
        }

        public override bool DeleteRole(string roleName, bool throwOnPopulatedRole)
        {
            throw new NotImplementedException();
        }

        public override string[] FindUsersInRole(string roleName, string usernameToMatch)
        {
            throw new NotImplementedException();
        }

        public override string[] GetAllRoles()
        {
            return RoleDAO.FindAll().Select(x => x.NameRole).ToArray();
        }

        public override string[] GetRolesForUser(string Username)
        {
            try
            {
                return RoleDAO.FindUserRoles(Username).Where(x => !x.IsNew && x.Status).Select(x => x.Role.NameRole).ToArray();
            }
            catch (Exception e)
            {
                throw new Exception("Erro ao obter roles do usuário - " + e.Message);
            }
        }

        public List<UserRole> GetAllRolesForUser(string Username)
        {
            try
            {
                return RoleDAO.FindUserRoles(Username);
            }
            catch (Exception e)
            {
                throw new Exception("Erro ao obter roles do usuário - " + e.Message);
            }
        }

        public override string[] GetUsersInRole(string roleName)
        {
            return UserRoleDAO.FindAll().Where(x => x.Role.NameRole.Equals(roleName)).Select(x => x.User.Email).ToArray();
        }

        public override bool IsUserInRole(string Username, string RoleName)
        {
            try
            {
                return RoleDAO.FindUserRoles(Username).Any(x => x.Role.NameRole.Equals(RoleName));
            }
            catch (Exception e)
            {
                throw new Exception("Erro ao validar role de usuário - " + e.Message);
            }
        }

        public override void RemoveUsersFromRoles(string[] usernames, string[] roleNames)
        {
            throw new NotImplementedException();
        }

        public override bool RoleExists(string roleName)
        {
            return RoleDAO.FindAll().Select(x => x.NameRole).ToArray().Contains(roleName);
        }
    }
}