﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Principal;
using System.Web;
using System.Web.Security;

namespace TpmMVC.Controllers
{
    public class UserIdentity : IIdentity, IPrincipal
    { 
        private readonly FormsAuthenticationTicket _ticket;

        public UserIdentity(FormsAuthenticationTicket ticket)
        {
            _ticket = ticket;
        }

        public UserIdentity()
        {

        }

        public string Name
        {
            get { return _ticket.Name; }
        }

        public string UserEmail
        {
            get { return _ticket.UserData; }
        }

        public IIdentity Identity
        {
            get { return this; }
        }

        public string AuthenticationType
        {
            get { return "Safe"; }
        }


        public bool IsAuthenticated
        {
            get { return _ticket != null ? true : false; }
        }

        public bool IsInRole(string role)
        {
            return Roles.IsUserInRole(role);
        }
    }
}