﻿$(document).ready(function () {

    $('#btnRegister').on('click', function (e) {
        e.preventDefault();
        OpenModal('/UserLogin/Register', 'modal-lg');
    });

    $(document).on('keydown', '.justNumber', function (e) {
        JustNumber(e);
    });

    $(document).on('keydown', '.decimal', function (e) {
        JustDecimalNumber(e);
    });

    $('table').on('keydown', '.decimal', function (e) {
        JustDecimalNumber(e);
    });

    $('#btnForgorPassWord').on('click', function (e) {
        e.preventDefault();
        OpenModal(this, 'modal-xsm');
    });

    $('#btnPremiumRequest').on('click', function (e) {
        e.preventDefault();
        OpenModal(this, 'modal-xsm');
    });

    $('body').on('click', '#btnCep', function (e) {
        let Cep = $('#Cep').val();
        FillCep(e, Cep.replace('-', ''), false);
    });

    $('body').on('click', '#btnUpCep', function (e) {
        let Cep = $('#UpCep').val();
        FillCep(e, Cep.replace('-', ''), true);
    });

    $('body').on('change', '#State', function (e) {
        let IdState = $('#State').val();
        let newCombo = '';
        if (IdState !== "0") {
            $.getJSON('/Base/GetCitiesList', { IdState: IdState }, function (content) {
                if (content && content.hasOwnProperty('Type') && content.Type === 2)
                    alertify.error(content.Message);
                else {
                    $.each(content, function (Key, Value) {
                        newCombo += '<option value="' + Value.Key + '">' + Value.Value + '</option>';
                    });
                    $('#City').empty();
                    $('#City').append(newCombo);
                }
            });
        }
        else {
            newCombo += '<option value="0">Selecione</option>';
            $('#City').empty();
            $('#City').append(newCombo);
        }
    });

    $('body').on('change', '#UpState', function (e) {
        let IdState = $('#UpState').val();
        let newCombo = '';
        if (IdState !== "0") {
            $.getJSON('/Base/GetCitiesList', { IdState: IdState }, function (content) {
                if (content && content.hasOwnProperty('Type') && content.Type === 2)
                    alertify.error(content.Message);
                else {
                    $.each(content, function (Key, Value) {
                        newCombo += '<option value="' + Value.Key + '">' + Value.Value + '</option>';
                    });
                    $('#UpCity').empty();
                    $('#UpCity').append(newCombo);
                }
            });
        }
        else {
            newCombo += '<option value="0">Selecione</option>';
            $('#UpCity').empty();
            $('#UpCity').append(newCombo);
        }
    });

    $('#btnLogOut').on('click', function (e) {
        alertify.confirm('Sair', 'Tem certeza que desjea sair?',
            function () { location.href = "/UserLogin/LogOut"; }, function () { }).set().resizeTo('200', '180');
    });

    $('.btn-close').on('click', function (e) {
        e.preventDefault();
        $(this).closest('.tab-content').addClass('hide');
        if ($(this).hasClass('btn-close-main'))
            $('.panel-Main').trigger('click');

    });

    $('.btn-minimize').on('click', function (e) {
        e.preventDefault();
        $(this).closest('.tab-content').find('.minimize').trigger('click');
    });

    $(window).on('resize', function (e) {
        $.fn.dataTable.tables({ visible: true, api: true }).columns.adjust();
        $(window).trigger('scroll');
    });

    $('input[type="checkbox"]').on('change', function (e) {
        let status = $('#' + e.target.id + ':checked').length > 0;
        $('#' + e.target.id).val(status);
    });

    $('body').on('show.bs.collapse shown.bs.collapse', function (e) {
        $.fn.dataTable.tables({ visible: true, api: true }).columns.adjust();
    });

    $('table').on('change', '.modal-Field', function (e) {
        e.preventDefault();
        let table = $('#' + e.delegateTarget.id).DataTable();
        let cell = $(this).closest('td');
        if (this.value !== null && this.value !== undefined && this.value !== '') {
            if (this.type === 'text' || this.type === 'number') {
                if (this.value.toString().indexOf(',') > -1)
                    table.cell(cell).data(FloorFigure(parseFloat(AlterComma(this.value)))).draw(false);
                else
                    table.cell(cell).data(this.value).draw(false);
            }
            else if (this.type === 'checkbox') {
                if (this.checked)
                    table.cell(cell).data(true).draw(false);
                else
                    table.cell(cell).data(false).draw(false);
            }
        }
    });

    $('.minimize').on('click', function (e) {
        let button = $(this).closest('.panel-heading').find('.buttons-panel').find('.btn-minimize');
        if (button.find('i').hasClass('fa-window-minimize')) {
            button.find('i').removeClass('fa-window-minimize').addClass('fa-window-maximize');
            button.attr('data-balloon', 'Maximizar');
        }
        else {
            button.find('i').removeClass('fa-window-maximize').addClass('fa-window-minimize');
            button.attr('data-balloon', 'Minimizar');
        }

    });

    $('#calendar-hide').on('click', function (e) {
        let Type = $('#calendar-hide').find('i').hasClass('fa-chevron-right');
        if (Type) {
            $('#calendar-Events').toggle("slide", { direction: "right", width: "282px" });
            $(this).empty().append('<i class="fa fa-chevron-left fa-2x arrow-Calendar" aria-hidden="true">');
            $('.calendar-panel').css('width', 'unset');
        }
        else {
            $('#calendar-Events').toggle("slide", { direction: "right", autoWidth: false });
            $(this).empty().append('<i class="fa fa-chevron-right fa-2x arrow-Calendar" aria-hidden="true">');
            $(this).css('float', '');
            $('.calendar-panel').css('width', '320px');
        }
        $.cookie("events", null, { path: '/' });
        $.removeCookie("events", { path: '/' });
        $.cookie("events", !Type, { expires: 1, path: '/' });

    });

    $('#messages-hide').on('click', function (e) {
        let Type = $('#messages-hide').find('i').hasClass('fa-chevron-right');
        if (Type) {
            $('#messages-container').toggle("slide", { direction: "right", width: "282px" });
            $(this).empty().append('<i class="fa fa-chevron-left fa-2x arrow-Calendar" aria-hidden="true">');
            $('.messages-panel').css('width', 'unset');
        }
        else {
            $('#messages-container').toggle("slide", { direction: "right", autoWidth: false });
            $(this).empty().append('<i class="fa fa-chevron-right fa-2x arrow-Calendar" aria-hidden="true">');
            $(this).css('float', '');
            $('.messages-panel').css('width', '320px');
        }
        $.cookie("messages", null, { path: '/' });
        $.removeCookie("messages", { path: '/' });
        $.cookie("messages", !Type, { expires: 1, path: '/' });

    });

    $(window).scroll(function (e) {
        let Space = 0;
        let width = $(window).width();
        if (width > 975.46)
            Space = 62.33;
        else if (width > 330 && width <= 975.46)
            Space = 107.87;
        else if (width)
            Space = 160.6;
        var $el = $(Element);
        var isPositionFixed = ($el.css('position') == 'fixed');
        if ($(this).scrollTop() > Space) {
            $(Element).css({ 'top': '0px' });
        }
        if ($(this).scrollTop() < Space) {
            $(Element).css({ 'top': Space + 'px' });
        }
    });

    GlobalConfig();

    IniConfigDataTables();

});

function GlobalConfig() {

    if ($(document).attr('title') === 'Login')
        $('body').css('background-image', 'url(/Content/Images/Startbackground.png)');

    if (errorMessage !== "")
        alertify.error(errorMessage);
    if (successMessage !== "")
        alertify.success(successMessage);
    if (infoMessage !== "")
        alertify.infoMessage(infoMessage);
    if (warningMessage !== "")
        alertify.warningMessage(warningMessage);

    Category = false;

    Element = '';
    if ($('#messages-container').length > 0)
        Element = $('.messages-panel');
    else
        Element = $('.calendar-panel');

    $(window).scroll();
    LoadMasks();

    $.ajaxSetup({
        async: false
    });

    let Data = null;

    setTimeout(function () {
        let ShowCalendar = $.cookie('events');
        if (ShowCalendar !== undefined && ShowCalendar !== null && !ConvertToBoolean(ShowCalendar)) {
            $('#calendar-hide').trigger('click');
        }
        let ShowMessages = $.cookie('messages');
        if (ShowMessages !== undefined && ShowMessages !== null && !ConvertToBoolean(ShowMessages)) {
            $('#messages-hide').trigger('click');
        }
    }, 1000);

    LoadEvents(Data);

    LoadMessages(Data);
}

function LoadEvents(Data) {
    setTimeout(function (e) {
        let Exists = $('#calendar-Events').length > 0;
        if (Exists) {
            if (Data === undefined || Data === null) {
                Data = GetJsonWithOutParam('/Base/GetEvents');
            }

            $('#calendar-Events').eventCalendar({
                eventsLimit: 0,
                monthNames: ["Janeiro", "Fevereiro", "Março", "Abril", "Maio", "Junho",
                    "Julho", "Agosto", "Setembro", "Outubro", "Novembro", "Dezembro"],
                dayNames: ['Domingo', 'Segunda', 'Terça', 'Quarta',
                    'Quinta', 'Sexta', 'Sábado'],
                dayNamesShort: ['Dom', 'Seg', 'Ter', 'Qua', 'Qui', 'Sex', 'Sab'],
                txt_noEvents: "Nenhuma partida nesse período",
                txt_SpecificEvents_prev: "",
                txt_SpecificEvents_after: "partidas:",
                txt_next: "próximo",
                txt_prev: "anterior",
                txt_NextEvents: "Próximas partidas:",
                txt_GoToEventUrl: "Ver evento",
                showDayAsWeeks: true,
                startWeekOnMonday: true,
                showDayNameInCalendar: true,
                showDescription: true,
                onlyOneDescription: false,
                openEventInNewWindow: false,
                eventsScrollable: true,
                jsonDateFormat: 'human', // you can use also "human" 'YYYY-MM-DD HH:MM:SS'
                moveSpeed: 500,	// speed of month move when you clic on a new date
                moveOpacity: 0.15, // month and events fadeOut to this opacity
                jsonData: Data, 	// to load and inline json (not ajax calls)
                cacheJson: true	// if true plugin get a json only first time and after plugin filter events
                // if false plugin get a new json on each date change
            });
        }
    }, 100);
}

function LoadMessages(Data) {
    let Message = '';
    let Exists = $('#messages-container').length > 0;
    if (Exists) {
        if (Data === undefined || Data === null)
            Data = GetJsonWithOutParam('/RestrictedArea/Message/GetMessages');
        if (Data !== undefined && Data !== null && Data.length > 0) {
            $('.messages-body').empty();
            for (var i = 0; i < Data.length; i++) {
                Message = FillMessage(Data[i]);
                $('.messages-body').append(Message);
            }
        }
        else {
            Message = '<p style="text-align: center;">Nenhuma mensagem encontrada!</p>';
            $('.messages-body').append(Message);
        }
    }
}

function ReadMessage(IdMessage, Read, e) {
    ShowSpinner();
    if (!Read) {
        OpenModalWithParam('/RestrictedArea/Message/ReadMessage', 'modal-md', IdMessage);
    }
    else {
       let Data =  GetJson('/RestrictedArea/Message/SetMessageRead', IdMessage);
       if (Data.Type == 1)
           GetMessage(Data);
       LoadMessages();
    }
    setTimeout(function () {
        HideSpinner();
    }, 100);

}

function UserInfo(IdUser) {
    ShowSpinner();
    OpenModalWithParam('/RestrictedArea/Home/GetUserInfo', 'modal-lg', IdUser);
    setTimeout(function () {
        HideSpinner();
    }, 100);
}

function FillMessage(Data) {

    let Envelop = '';
    let Message = '';

    if (Data.MessageBody.length > 120)
        Message = Data.MessageBody.substring(0, 120) + ' ...';
    else
        Message = Data.MessageBody;

    if (!Data.IsRead)
        Envelop = '<i class="fa fa-envelope" aria-hidden="true"></i>';
    else
        Envelop = '<i class="fa fa-envelope-open-o" aria-hidden="true"></i>';

    let newMessage = '<div class="message-panel">' +
        '<div class="message-header">' +
        Envelop + ' ' + 
        '<a href="#" onclick="UserInfo(' + Data.IdUser + ');">' + Data.User + '</a>' + 
    '<div class="date"><i class="fa fa-clock-o" aria-hidden="true"></i> ' + Data.Date + '</div>' +
        '</div>' +
        '<hr class ="hr-message" />' +
        '<div class="message-body">' +
        '<h5 class="message-subject">' + Data.Subject + '</h5>' +
        '<hr class ="hr-message" />' +
        Message +
        '</div>' +
        '<hr class ="hr-message" />' +
        '<div class="message-footer">' +
        '<button type="button" class="btn-warning btn-read" onclick="ReadMessage(' + Data.IdMessage + ', true, event);">Marcar como lida</button>' +
        '<button type="button" class="btn-info btn-read btn-read" onclick="ReadMessage(' + Data.IdMessage + ', false, event);">Ler</button>' +
        '</div>' +
        '</div>';

    return newMessage;

}

function LoginFacebook(isPremium) {

    ShowSpinner(true);
    if (isPremium)
        window.location.href = '/Account/Facebook?Premium=true';
    else
        window.location.href = '/Account/Facebook?Premium=false';
}

function IniConfigDataTables() {
    language = { "sEmptyTable": "Nenhum registro encontrado", "sInfo": "Mostrando de _START_ até _END_ de _TOTAL_ registros", "sInfoEmpty": "Mostrando 0 até 0 de 0 registros", "sInfoFiltered": "(Filtrados de _MAX_ registros)", "sInfoPostFix": "", "sInfoThousands": ".", "sLengthMenu": "_MENU_ Resultados por página", "sLoadingRecords": "Carregando...", "sProcessing": "Processando...", "sZeroRecords": "Nenhum registro encontrado", "sSearch": "Pesquisar", "oPaginate": { "sNext": "Próximo", "sPrevious": "Anterior", "sFirst": "Primeiro", "sLast": "Último" }, "oAria": { "sSortAscending": ": Ordenar colunas de forma ascendente", "sSortDescending": ": Ordenar colunas de forma descendente" }, select: { rows: "%d Selecionado(s)" } };

    //Default Config for all DataTables 
    $.extend(true, $.fn.dataTable.defaults, {
        language: language,
        responsive: true,
        processing: true,
        paging: true,
        searching: true,
        autoWidth: true,
        sort: true,
        destroy: true,
        lengthChange: true,
        columnDefs: [{ "className": "dt-center", "targets": "_all" }]
    });
}

function FillCep(e, Cep, Up) {
    e.preventDefault();
    if (Cep.length === 8 && $.isNumeric(Cep)) {
        $.getJSON("//viacep.com.br/ws/" + Cep + "/json/?callback=?", function (dados) {
            if (!("erro" in dados)) {
                //Atualiza os campos com os valores da consulta.
                if (Up) {
                    $("#UpStreet").val(dados.logradouro);
                    $("#UpNeighborhood").val(dados.bairro);
                    $('#UpState option:contains(' + dados.uf + ')').prop('selected', 'selected');
                    $('#UpState').trigger('change');
                    setTimeout(function () {
                        $('#UpCity option:contains(' + dados.localidade + ')').prop('selected', 'selected').trigger('change');
                        $(".UphideAddress").removeClass('hide');
                        $(".UphideAddress").css('display', '');
                    }, 1000);

                } else {
                    $("#Street").val(dados.logradouro);
                    $("#Neighborhood").val(dados.bairro);
                    $('#State option:contains(' + dados.uf + ')').prop('selected', 'selected');
                    $('#State').trigger('change');
                    setTimeout(function () {
                        $('#City option:contains(' + dados.localidade + ')').prop('selected', 'selected').trigger('change');
                        $(".hideAddress").removeClass('hide');
                        $(".hideAddress").css('display', '');
                    }, 1000);
                }
            } //end if.
            else {
                alertify.error('CEP não encontrado!');
            }
        });
    } else
        alertify.error('CEP inválido!');
}

function JustNumber(event) {
    /* Allow delete, tab, esc e enter */
    var tecla = window.event ? event.keyCode : event.which;

    if (tecla === 46 || tecla === 9 || tecla === 27 || tecla === 13 ||
        /* Allow CTRL+A */

        tecla === 65 && event.ctrlKey === true ||

        /* Allow CTRL+C */
        tecla === 67 && event.ctrlKey === true ||

        /* Allow CTRL+X */
        tecla === 88 && event.ctrlKey === true ||

        /* Allow CTRL+V */
        tecla === 17 && event.ctrlKey === true ||

        tecla === 86 && event.ctrlKey === true ||

        /* Allow Command+A (Mac) */
        tecla === 65 && event.metaKey === true ||

        /* Allow Command+C (Mac) */
        tecla === 67 && event.metaKey === true ||

        /* Allow Command+X (Mac) */
        tecla === 88 && event.metaKey === true ||

        /* Allow Command+V (Mac) */
        tecla === 86 && event.metaKey === true ||

        /* Allow home, end, left e right keys */
        tecla >= 35 && tecla <= 39) {

        return false;
    }
    else {
        if (tecla === 8) {
            return true;
        }
        else if (event.shiftKey || (tecla < 48 || tecla > 57) && (tecla < 96 || tecla > 105)) {
            event.preventDefault();
        }

    }
}

//Just Decimal numbers function for TextBox
function JustDecimalNumber(event) {
    /* Allow delete, tab, esc e enter */
    var tecla = window.event ? event.keyCode : event.which;

    if (tecla === 46 || tecla === 9 || tecla === 27 || tecla === 13 ||
        /* Allow CTRL+A */

        tecla === 65 && event.ctrlKey === true ||

        /* Allow CTRL+C */
        tecla === 67 && event.ctrlKey === true ||

        /* Allow CTRL+X */
        tecla === 88 && event.ctrlKey === true ||

        /* Allow CTRL+V */
        tecla === 17 && event.ctrlKey === true ||

        tecla === 86 && event.ctrlKey === true ||

        /* Allow Command+A Mac */
        tecla === 65 && event.metaKey === true ||

        /* Allow Command+C Mac */
        tecla === 67 && event.metaKey === true ||

        /* Allow Command+X Mac */
        tecla === 88 && event.metaKey === true ||

        /* Allow Command+V Mac */
        tecla === 86 && event.metaKey === true ||

        /* Allow home, end, left e right keys */
        tecla >= 35 && tecla <= 39 ||
        /*Allow "," decimal */
        tecla === 110 ||

        tecla === 188) {

        return false;
    }
    else {
        if (tecla === 8) {
            return true;
        }
        else if (event.shiftKey || (tecla < 48 || tecla > 57) && (tecla < 96 || tecla > 105)) {
            event.preventDefault();
        }

    }
}

function GetDataFromTable(tableId, e) {
    let table = $(tableId).DataTable();
    let data = table.row(e.parents('tr')).data();
    //Get Data from DataTable, if responsive, then change how get data
    if (data === undefined)
        data = table.row(e.parent().prev()).data();
    return data;
}

function GetJson(Url, Param) {
    let data;
    $.getJSON(Url, { Param: Param }, function (dados) {
        if (dados && dados.hasOwnProperty('Type') && dados.Type === 2) {//error
            alertify.error(dados.Message);
            data = null;
        } //end if.
        else
            data = dados;
    });
    return data;
}

function GetJsonWithOutParam(Url) {
    let data;
    $.getJSON(Url, function (dados) {
        if (dados && dados.hasOwnProperty('Type') && dados.Type === 2) {//error
            alertify.error(dados.Message);
            data = null;
        } //end if.
        else
            data = dados;
    });
    return data;
}

function LoadMasks() {
    $('.cpf').mask('999.999.999-99');
    $('.tel').mask('(99) 99999-9999');
    $('.cep').mask('99999-999');
    $('.money').mask('00000000000,00', { reverse: true });
}

function SubmitForm(url, fdata, e) {
    e.preventDefault();
    let data;
    $.ajax({
        url: url,
        method: 'post',
        data: fdata,
        success: function (content) {
            HideSpinner();
            if (typeof content === 'string') {
                $('#modal-Register').html(content);
                data = null;
            }
            else if (content && content.hasOwnProperty('Type')) {
                data = content;
                if (content.Type === 1)
                    $('#modal-Register').modal('hide');
                GetMessage(content);
            }
        },
        processData: false,
        contentType: false,
        async: false,
        cache: false
    });
    return data;
}

function SubmitFormwithDataTable(url, fdata, e) {
    e.preventDefault();
    let data;
    $.ajax({
        url: url,
        method: 'post',
        data: fdata,
        success: function (content) {
            HideSpinner();
            data = content;
        },
        processData: false,
        contentType: false,
        async: false,
        cache: false
    });
    return data;
}

function OpenModal(url, classModal) {
    $.ajax({
        url: url,
        type: "GET",
        dataType: "html",
        success: function (content) {
            if (typeof content === 'string') {
                $('#modal-Register').empty();
                $('#modal-Register').html(content);
                $('#modal-Register').find('.modal-dialog').addClass(classModal);
                $('#modal-Register').modal('show');
            }
            else
                GetMessage(content);
        }
    });
}

function OpenModalWithParam(url, classModal, param) {
    $.ajax({
        url: url,
        type: "GET",
        data: { Param: param },
        dataType: "html",
        success: function (content) {
            if (typeof content === 'string') {
                $('#modal-Register').empty();
                $('#modal-Register').html(content);
                $('#modal-Register').find('.modal-dialog').addClass(classModal);
                $('#modal-Register').modal('show');
            }
            else
                GetMessage(content);

        }
    });
}

function GetMessage(content) {
    if (content && content.hasOwnProperty('Type') && content.Type === 1) //success
        alertify.success(content.Message);
    else if (content && content.hasOwnProperty('Type') && content.Type === 2) //error
        alertify.error(content.Message);
    else if (content && content.hasOwnProperty('Type') && content.Type === 3) //warning
        alertify.warning(content.Message);
    else if (content && content.hasOwnProperty('Type') && content.Type === 4) //info
        alertify.infoMessage(content.Message);

    setTimeout(function () {

        if (content.Redirect && content.Url === '')
            window.location.reload(true);
        else if (content.Redirect && content.Url !== '')
            RedirectTo(content.Url);
    }, 2000);
}

function FormatDate(data) {
    if (data !== undefined && data.match('^/Date')) {
        var d = /\/Date\((\d*)\)\//.exec(data);
        return d ? new Date(+d[1]) : data;
    }
    else
        return data;
}

function Menu() {
    var x = document.getElementById("myTopnav");
    if (x.className === "topnav") {
        x.className += " responsive";
    } else {
        x.className = "topnav";
    }
}

function ShowSpinner(White) {
    if (White !== undefined && White !== null && White)
        $('.spinner-load').css('color', 'white');

    $('.spinner-load').css('display', 'block');
}

function HideSpinner() {
    $('.spinner-load').css('display', 'none');
}

function RedirectTo(Url) {
    window.location.href = Url;
}

jQuery(window).on('orientationchange', function (e) {
    $.fn.dataTable.tables({ visible: true, api: true }).columns.adjust();
});

//Change ',' to '.'
function AlterComma(val) {
    if (val.toString().indexOf(',') > -1) {
        let newval = val.toString().replace(",", ".");
        return newval;
    } else
        return val;
}

//Change '.' to ','
function AlterDot(val) {
    if (val.toString().indexOf('.') > -1) {
        let newval = val.toString().replace(".", ",");
        return newval;
    } else
        return val;
}

//Format decimal numbers with given decimal places
function FloorFigure(figure, decimals) {
    if (!decimals) decimals = 2;
    let d = Math.pow(10, decimals);
    return parseFloat((parseInt(figure * d) / d).toFixed(decimals));
}

function CheckAllCheckBoxes(e, checked) {
    let table = $('#' + e.delegateTarget.id).DataTable();
    let Data = table.rows().data();
    for (var i = 0; i < Data.length; i++) {
        if (checked)
            Data[i].Active = true;
        else
            Data[i].Active = false;
    }
    table.clear().rows.add(Data).columns.adjust().draw();

}

function RemoveRow(e, row) {
    let table = $('#' + e.delegateTarget.id).DataTable();
    let data = table.row($(row).parents('tr')).data();
    if (data !== undefined)
        table.row($(row).parents('tr')).remove().columns.adjust().draw();
    else
        table.row($(row).parent().prev()).remove().columns.adjust().draw();

    $.fn.dataTable.tables({ visible: true, api: true }).columns.adjust();
}

//Cast to bool
function ConvertToBoolean(value) {
    //VALIDATE INPUT
    if (typeof value === 'undefined' || value === null) return false;

    //DETERMINE BOOLEAN VALUE FROM STRING
    if (typeof value === 'string') {
        switch (value.toLowerCase()) {
            case 'true':
            case 'yes':
                return true;
            case 'false':
            case 'no':
                return false;
        }
    }
}

function isMobileDevice() {
    var isMobile = false; //initiate as false
    // device detection
    if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(navigator.userAgent)
        || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(navigator.userAgent.substr(0, 4))) isMobile = true;
    return isMobile;
}