﻿$(document).ready(function (e) {
    InitializeModal();

    $(window).on('resize', function (e) {
        $.fn.dataTable.tables({ visible: true, api: true }).columns.adjust();
    });

    //$('#CategoriesBtn').on('click', function (e) {
    //    setTimeout(function () {
    //        $.fn.dataTable.tables({ visible: true, api: true }).columns.adjust();
    //    }, 1);
    //});

    $('#btnAddUmpire').on('click', function (e) {
        e.preventDefault();
        ShowSpinner();
        let table = $('#table-UmpiresCad').DataTable();
        let Email = $('#UserEmail').val();
        let Data = table.rows().data();
        if (Email !== '') {
            if ($.grep(Data, function (n) { return n.Email === Email; }).length > 0)
                alertify.warning("Usuário já foi selecionado!");
            else {
                let UserData = GetJson('/RestrictedArea/User/GetUserInfo', Email);

                if (UserData !== null && UserData !== undefined && !UserData.hasOwnProperty('Type')) {
                    let Umpire = FillUmpireObject(UserData, 0);
                    table.row.add(Umpire).columns.adjust().draw();
                }
                else
                    alertify.warning('Nenhum usuário encontrado!\nInforme um e-mail válido!');
            } 
        }
        else
            alertify.warning('Informe o email do usuário!');
        HideSpinner();
    });

    $('table').on('change', '.modal-Field', function (e) {
        e.preventDefault();
        let table = $('#' + e.delegateTarget.id).DataTable();
        let cell = $(this).closest('td');
        if (this.value !== null && this.value != undefined && this.value !== '') {
            if (this.type === 'text' || this.type === 'number') {
                if (this.value.toString().indexOf(',') > -1)
                    table.cell(cell).data(FloorFigure(parseFloat(AlterComma(this.value)))).draw(false);
                else
                    table.cell(cell).data(this.value).draw(false);
            }
            else if (this.type === 'checkbox') {
                if (this.checked)
                    table.cell(cell).data(true).draw(false);
                else
                    table.cell(cell).data(false).draw(false);
            }
        }
    });

    $('table').on('click', '.checkAll', function (e) {
        CheckAllCheckBoxes(e, this.checked);
    });

    $('#table-UmpiresCad').on('click', '#btnRemoveUmpire', function (e) {
        RemoveUmpire(e, $(this));
    });
});

$('#formRegisterUser').on('submit', function (e) {
    e.preventDefault();
    ShowSpinner();
    let fdata = new FormData($(this)[0]);
    setTimeout(function () {
        SubmitForm('/UserLogin/Register', fdata, e);
    }, 100);
});

$('#formForgotPassword').on('submit', function (e) {
    e.preventDefault();
    ShowSpinner();
    let fdata = new FormData($(this)[0]);
    setTimeout(function () {
        SubmitForm('/UserLogin/ForgotPassword', fdata, e);
    }, 100);

});

$('#formPremiumRequest').on('submit', function (e) {
    e.preventDefault();
    ShowSpinner();
    let fdata = new FormData($(this)[0]);
    setTimeout(function () {
        SubmitForm('/UserLogin/PremiumRequest', fdata, e);
    }, 100);
});

$('#formRegisterFacility').on('submit', function (e) {
    e.preventDefault();
    ShowSpinner();
    let fdata = new FormData($(this)[0]);

    setTimeout(function () {
            let data = SubmitForm('/RestrictedArea/Facility/SaveFacilityAsync', fdata, e);
            if (data !== null && data.Type === 1)
                ResetViewFacility();
        }, 100);

});

$('#formRegisterTournament').on('submit', function (e) {
    e.preventDefault();
    ShowSpinner();
    let Categories = [];
    let Umpires = [];
    let AllCategory = $('#table-CategoriesCad').DataTable().rows().data();
    let AllUmpires = $('#table-UmpiresCad').DataTable().rows().data();

    for (var i = 0; i < AllCategory.length; i++) {
        if (AllCategory[i].Active) 
            Categories.push(AllCategory[i]);
    }

    for (var i = 0; i < AllUmpires.length; i++)
        Umpires.push(AllUmpires[i]);
    let fdata = new FormData($(this)[0]);
    fdata.append("Categories", JSON.stringify(Categories));
    fdata.append("Umpires", JSON.stringify(Umpires));

    setTimeout(function () {
        let data = SubmitFormwithDataTable('/RestrictedArea/Tournament/SaveTournamentAsync', fdata, e);
        debugger;
        if (typeof data === 'string') {
            $('#modal-Register').html(data);
            FillTournamentsDataOnFailure();
        } else { 
        GetMessage(data);
        if (data.Type !== 2) {
            $('#modal-Register').modal('hide');
            ResetView();
        }
    }
    }, 100);

});

$('table').on('click dblclick', '.modal-Field', function (e) {
    e.stopPropagation();
});

function InitializeModal() {

    $(":file").filestyle();

    let Categories = $('#CategoriesJsonCad').val();

    if (Category !== undefined && Category && Categories === '') {
        BuildCatDataTable('Cad');
        GetCatergories();
    }

    LoadMasks();

    $.fn.dataTable.tables({ visible: true, api: true }).columns.adjust();

}