﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using TpmMVC.Areas.RestrictedArea.Models.Tournament;

namespace TpmMVC.Util.CustomValidators
{
    public class DateEndTournamentValidator : ValidationAttribute
    {
        protected override ValidationResult IsValid(object value, ValidationContext validationContext)
        {
            try
            {
                if (value != null)
                {
                    DateTime EndDate = (DateTime)value;

                    var Model = (TournamentViewModel)validationContext.ObjectInstance;

                    if (Model.StartDate.Date != DateTime.MinValue && EndDate.Date > Model.StartDate.Date)
                        return ValidationResult.Success;
                    else
                        return new ValidationResult(FormatErrorMessage(validationContext.DisplayName));
                }
                else
                    return new ValidationResult(FormatErrorMessage(validationContext.DisplayName));
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }
    }
}