﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace TpmMVC.Util.CustomValidators
{
    public class FileValidator : ValidationAttribute
    {

        public override bool IsValid(object value)
        {
            if (value != null)
           {
                if (value.GetType().IsGenericType)
                {
                    var List = (List<HttpPostedFileBase>)value;
                    if (List.Count > 0 && List.FirstOrDefault() != null)
                    {
                        var Valid = true;
                        foreach (var item in List)
                        {
                            if (!Helpers.CheckFile(item))
                                Valid = false;
                        }
                        return Valid;
                    }
                    else
                        return true;
                }
                else
                    return Helpers.CheckFile((HttpPostedFileBase)value);
            }               
            else
                return true;
        }

    }
}