﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace TpmMVC.Util.CustomValidators.Session
{
    public class SessionExpire : ActionFilterAttribute
    {
        public override void OnActionExecuting(ActionExecutingContext filterContext)
        {
            var Action = filterContext.ActionDescriptor.ControllerDescriptor.ControllerType.CustomAttributes.Any(x => x.AttributeType == typeof(AllowAnonymousAttribute));
            if (filterContext.ActionDescriptor.ControllerDescriptor.ControllerName.Equals("Base"))
            {
                if (filterContext.ActionDescriptor.IsDefined(typeof(AllowAnonymousAttribute), true))
                    Action = true;
                else
                    Action = false;
            }
            if (Action)
                base.OnActionExecuting(filterContext);
            else
            {
                var User = SessionManager.GetUserData();
                if (!HttpContext.Current.Request.IsAuthenticated || User == null)
                {
                    SessionManager.SignOut();
                    filterContext.Result = new RedirectToRouteResult(new RouteValueDictionary(new { area = "", action = "Index", controller = "UserLogin", msg = "Sessão expirada! Faça Login novamente!" }));
                    return;
                }
            }
        }
    }
}