﻿using GuigleAPI;
using GuigleAPI.Model;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using TpmDAO.Entity;
using TpmDAO.Persistence;

namespace TpmMVC.Util
{
    public class Helpers
    {

        #region DropDowns

        public static IEnumerable<SelectListItem> FillDropDown(Dictionary<string, string> oDictionary)
        {
            try
            {
                if (oDictionary != null)
                {
                    if (!oDictionary.ContainsKey("0"))
                        oDictionary.Add("0", "Selecione");
                    if (oDictionary.Count == 2)
                        return new SelectList(oDictionary.OrderByDescending(x => x.Value == "Selecione").ThenBy(y => y.Value), "Key", "Value", oDictionary.ElementAt(0).Key);
                    else
                        return new SelectList(oDictionary.OrderByDescending(x => x.Value == "Selecione").ThenBy(y => y.Value), "Key", "Value");
                }
                else
                    return Enumerable.Empty<SelectListItem>();
            }
            catch (Exception)
            {
                return Enumerable.Empty<SelectListItem>();
            }

        }

        #endregion

        #region Files

        public static string SaveFile(HttpPostedFileBase file, string Folder)
        {
            try
            {
                if (!CheckFile(file) || file.ContentLength > 8388608)
                    return "Arquivo inválido";

                Directory.CreateDirectory(HttpContext.Current.Server.MapPath("~/TempUpload\\" + Folder + "\\"));

                var path = HttpContext.Current.Server.MapPath("~/TempUpload\\" + Folder + "\\");

                var result = Guid.NewGuid().ToString() + Path.GetExtension(file.FileName);

                file.SaveAs(path + result);

                return path + result;
            }
            catch (Exception)
            {
                return "";
            }
        }

        public static string GenerateFileName(string FilePath)
        {
            try
            {
                return Guid.NewGuid().ToString() + Path.GetExtension(FilePath);
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

        public static bool CheckFile(HttpPostedFileBase file)
        {
            switch (file.ContentType)
            {
                case "image/jpeg":
                    return true;
                case "image/png":
                    return true;
                case "image/bmp":
                    return true;
                default:
                    return false;
            }
        }

        public static void DeleteFile(string Path)
        {
            try
            {
                if (File.Exists(Path))
                    File.Delete(Path);
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

        #endregion

        #region Get Longitude/Latitude

        public static async Task<Location> GetGeoPositionAsync(TpmDAO.Entity.Address Address)
        {
            try
            {
                Address.City = CityDAO.FindByKeyComplete(Address.IdCity);
                GoogleGeocodingAPI.GoogleAPIKey = "AIzaSyCTLbPcPimnn4gbGftDhLUajtw7Lm3YSXQ";
                AddressResponse result = await GoogleGeocodingAPI.SearchAddressAsync(Address.ToString());
                var Location = result.Results.FirstOrDefault();
                return Location?.Geometry.Location;
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
        }

        #endregion

    }
}