﻿using System;
using System.IO;
using System.Net.Mail;
using System.Net.Mime;

namespace Utils
{
    public class SmtpServer
    {
        private static string Account { get; } = "tenistpm@outlook.com";

        private static string Img { get; set; } = "https://scontent.xx.fbcdn.net/v/t1.0-1/p200x200/17796339_1193130730813482_69038714782609707_n.jpg?oh=098cff66c2f450bd50deeeef42b6c0ab&oe=5A7B735A";

        private static string RegisterEmail { get; } = "<p>Olá, {0}!</p>" +
            "<p>Seu cadastro foi registrado com sucesso. Aproveite o melhor do sistema TPM.</p><br />" +
            "<p>Atenciosamente,</p>" +
            "<p><img src=\""+ Img + "\"width=\"50\" height=\"50\">Equipe TPM" +
            "<a href='http://tpmportal.azurewebsites.net/'>Acesse já!</a></p>";

        private static string ForgotPassword { get; } = "<p>Olá, {0}!</p>" +
            " <p> Para redefinir sua senha, acesso o link clicando <a href='http://localhost:54165/UserLogin/ResetPassword?Token=" + "{1}'>aqui</a>, e insira uma nova senha!</p> <br />" +
            "<p>Atenciosamente,</p>" +
           "<p><img src=\"" + Img + "\"width=\"50\" height=\"50\">Equipe TPM" +
            "<a href='http://tpmportal.azurewebsites.net/'>Acesse já!</a></p>";

        private static string NewRequest { get; } = "<p>Olá, {0}!</p>" +
            " <p>Sua requisição de acesso Premium foi feita com sucesso! Agora basta aguardar a aprovação</p> <br />" +
            "<p>Atenciosamente,</p>" +
           "<p><img src=\"" + Img + "\"width=\"50\" height=\"50\">Equipe TPM" +
            "<a href='http://tpmportal.azurewebsites.net/'>Acesse já!</a></p>";

        private static string RequestApproved { get; } = "<p>Olá, {0}!</p>" +

            " <p>Sua requisição de acesso Premium foi aprovada!<br />Estamos felizes em poder trabalhar com o Sr(a).</p> <br />" +
            "<p>Atenciosamente,</p>" +
           "<p><img src=\"" + Img + "\"width=\"50\" height=\"50\">Equipe TPM" +
            "<a href='http://tpmportal.azurewebsites.net/'>Acesse já!</a></p>";

        private static string RequestDenied { get; } = "<p>Olá, {0}!</p>" +
            " <p>Sua requisição de acesso Premium foi negada!</p> <br />" +
            "<p>Atenciosamente,</p>" +
           "<p><img src=\"" + Img + "\"width=\"50\" height=\"50\">Equipe TPM" +
            "<a href='http://tpmportal.azurewebsites.net/'>Acesse já!</a></p>";

        private static string ResponseEmail { get; } = "<p>Olá, {0}!</p>" +
            "<p>Em relação ao seus contato:</p>" +
            "<p>Data: {1};</p>"+
            "<p>Assunto: {2};</p>" +
            "<p>Mensagem: {3};</p>" +
            "<p>Resposta:</p>" +
            "<p>{4}</p></br>" +
            "<p>Atenciosamente,</p>" +
            "<p><img src=\"" + Img + "\"width=\"50\" height=\"50\">Equipe TPM" +
            "<a href='http://tpmportal.azurewebsites.net/'>Acesse já!</a></p>";

        public static void SendEmailWelcome(string UserEmail, string Name)
        {
            try
            {
                MailMessage msg = new MailMessage(Account, UserEmail)
                {
                    Subject = "Bem Vindo",
                    Body = string.Format(RegisterEmail, Name)

                };
                msg.IsBodyHtml = true;
                var smtp = new SmtpClient();
                smtp.Send(msg);
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static void SendEmailResetPassword(string UserEmail, string Name, string Token)
        {
            try
            {
                MailMessage msg = new MailMessage(Account, UserEmail)
                {
                    Subject = "Redefinição de senha",
                    Body = string.Format(ForgotPassword, Name, Token)
                };
                msg.IsBodyHtml = true;
                var smtp = new SmtpClient();
                smtp.Send(msg);
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static void SendEmailRequest(string UserEmail, string Name, int Type)
        {
            try
            {
                MailMessage msg = new MailMessage(Account, UserEmail)
                {
                    Subject = "Requisição de Acesso Premium",
                    Body = string.Format(Type == 0 ? NewRequest : Type == 1 ? RequestApproved : RequestDenied, Name)
                };

                msg.IsBodyHtml = true;
                var smtp = new SmtpClient();
                smtp.Send(msg);
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static void SendEmailResponse(string User, DateTime Date, string Subject, string MessageContent, string MessageResponse, string UserEmail)
        {
            try
            {
                MailMessage msg = new MailMessage(Account, UserEmail)
                {
                    Subject = "RES:" + Subject,
                    Body = string.Format(ResponseEmail, User, Date.ToString("dd/MM/yyyy HH:mm"), Subject, MessageContent, MessageResponse)

                };
                msg.IsBodyHtml = true;
                var smtp = new SmtpClient();
                smtp.Send(msg);
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static void SendMessageAttachment(Stream File, string UserEmail, string Message, string Subject)
        {
            try
            {
                MailMessage msg = new MailMessage(Account, UserEmail)
                {
                    Subject = Subject,
                    Body = Message
                };
                msg.IsBodyHtml = true;
                msg.Attachments.Add(new Attachment(File, "Chave.pdf", MediaTypeNames.Application.Pdf));

                var smtp = new SmtpClient();
                smtp.Send(msg);
            }
            catch (Exception e)
            {
                throw new Exception("Erro ao enviar email " + e.Message);
            }
        }

        //private static SmtpClient GetSmtpServer()
        //{
        //    SmtpClient smtp = new SmtpClient("smtp-mail.outlook.com");
        //    smtp.Port = 587;
        //    smtp.DeliveryMethod = SmtpDeliveryMethod.Network;
        //    smtp.UseDefaultCredentials = false;
        //    smtp.EnableSsl = true;
        //    smtp.ServicePoint.ConnectionLimit = 1000;
        //    smtp.Credentials = new NetworkCredential("luizbillsantos@live.com", "lfbs4545");
        //    return smtp;
        //}
    }
}