﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Utils
{
    public class Token
    {
        public string TokenData { get; set; }

        public DateTime Date { get; set; }

        public static string GenerateSafeToken()
        {
            try
            {
                byte[] time = BitConverter.GetBytes(DateTime.Now.ToBinary());
                byte[] key = Guid.NewGuid().ToByteArray();
                string token = Convert.ToBase64String(time.Concat(key).ToArray());
                return Encryption.Encrypt(token);
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }

        public static Token GetTokenInfo(string Token)
        {
            try
            {
                var oToken = new Token();
                Token = Encryption.Decrypt(Token);
                byte[] data = Convert.FromBase64String(Token);
                oToken.Date = DateTime.FromBinary(BitConverter.ToInt64(data, 0));
                oToken.TokenData = Token;
                return oToken;
            }
            catch (Exception e)
            {
                throw new Exception(ExceptionTreatment.GetExceptionDetails(e));
            }
        }
    }
}
